export declare type AnchorNavigationSection = {
    id: string;
    label: string;
};
export declare type AnchorNavigationElementSection = AnchorNavigationSection & {
    element: HTMLElement;
};
export interface AnchorNavigationProps {
    /**
     * An array of sections used in the anchor navigation.
     * @since 12.18.0
     */
    sections: AnchorNavigationSection[];
    /**
     * The ID of the currently selected section.
     * @since 12.18.0
     */
    selected: string;
    /**
     * Callback function to update the selected section ID.
     @since 12.18.0
     */
    onSelect: (id: string) => void;
}
export declare type AnchorProps = {
    label: string;
    selected: boolean;
    onClick: () => void;
};
