/// <reference types="react" />
import type { Props } from '../_utils/types';
export declare type BannerVariant = 'attention' | 'error' | 'info' | 'UNSAFE_attention_emphasized';
export interface BannerProps extends Props {
    /**
     * Sets the banner's variant.
     *
     * @since 10.19.0
     */
    variant: BannerVariant;
}
export interface BannerIconProps extends Props {
    /**
     * @since 10.19.0
     */
    icon: React.ReactNode;
}
export interface BannerExpandableContentProps extends Props {
    /**
     * Expands banner content
     * @since 10.19.0
     */
    expanded: boolean;
    /**
     * Max height for the expanded content pane. (Optional)
     * Defaults to 120.
     *
     * @since 11.5.*
     */
    expandableContentMaxHeight?: number;
}
