import type React from 'react';
import type { ButtonSizes, ButtonVariant, LinkButtonProps } from './Button.types';
export declare function getBGColor(variant: ButtonVariant): {
    main: string;
    hover: string;
    disabled: string;
};
export declare function getTextColor(variant: ButtonVariant): {
    main: string;
    disabled: string;
};
export declare const StyledContent: import("styled-components").StyledComponent<"span", any, {}, never>;
export declare const StyledSpinner: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<import("..").SpinnerProps & React.RefAttributes<HTMLDivElement>>, any, {}, never>;
export declare const StyledLabel: import("styled-components").StyledComponent<"span", any, {}, never>;
interface StyledButtonProps {
    disabled: boolean;
    $block: boolean;
    $loading: boolean;
    $size: ButtonSizes;
    $variant: ButtonVariant;
}
export declare function getButtonStyles(block: boolean, disabled: boolean, loading: boolean, size: ButtonSizes, variant: ButtonVariant): import("styled-components").FlattenSimpleInterpolation;
export declare const StyledButton: import("styled-components").StyledComponent<"button", any, StyledButtonProps, never>;
interface StyledLinkButtonProps extends Pick<StyledButtonProps, '$block' | '$size' | '$variant'> {
    as?: LinkButtonProps['as'];
    children?: React.ReactNode;
    href?: string;
    $disabled: boolean;
    ref?: React.RefCallback<HTMLAnchorElement>;
}
export declare const StyledLinkButton: import("styled-components").StyledComponent<"a", any, StyledLinkButtonProps, never>;
export {};
