import type { Props } from '../_utils/types';
/**
 * @deprecated
 */
export declare type CardLevel = '10' | '20' | '30' | '40' | '50';
export declare type ShadowStrength = 0 | 1 | 2 | 3 | 4;
export declare type CardVariant = 'hoverable';
export interface CardProps extends Props {
    /**
     * The card level for determining the shadow
     *
     * @deprecated
     *
     * The `level` prop has been deprecated and will be removed in a future version.
     * Please use the `shadowStrength` prop instead.
     *
     * **Before**
     *
     * <Card level={20} />
     *
     * **After**
     *
     * <Card shadowStrength={2} />
     *
     * @deprecatedSince 10.20.0
     * @since 10.19.0
     */
    level?: CardLevel;
    /**
     * Determines shadow strength
     *
     * @defaultValue 1
     * @since 10.19.0
     */
    shadowStrength?: ShadowStrength;
    /**
     * The card variant
     * @since 10.19.0
     */
    variant?: CardVariant;
}
