import type { ReactNode } from 'react';
import type { TooltipProps } from '../Tooltip';
import type { InputAttributes, Props } from '../_utils/types';
export interface CheckboxProps extends Props, InputAttributes {
    /**
     * Checked state of the checkbox
     * @since 10.19.0
     */
    checked?: boolean;
    /**
     * The contents of the checkbox label
     * @since 10.19.0
     */
    children?: ReactNode;
    /**
     * Additional classNames
     * @since 10.19.0
     */
    className?: string;
    /**
     * Disabled state of the checkbox
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * Error state of the checkbox
     * @since 10.19.0
     */
    error?: boolean;
    /**
     * Indeterminate state of the checkbox
     * @since 10.19.0
     */
    indeterminate?: boolean;
    /**
     * Whether to show requiredMark
     * @since 11.25.0
     */
    requiredMark?: boolean;
    /**
     * @since 11.25.0
     */
    tooltip?: TooltipProps['overlay'];
}
