import React from 'react';
import type { TypographyProps } from '../Typography/Typography.types';
import type { SpanAttributes } from '../_utils/types';
import type { ContactItemProps } from './ContactItem.types';
/**

 The contact item component is a more complex alternative to a standard line
 of text found in a list or form component. Use this component when you have
 a list or set of items that can benefit from an additional line of content or
 an avatar.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-contact-item--demo)

 @see [Design Guidelines](https://design.procore.com/contact-item)

*/
export declare const ContactItem: React.ForwardRefExoticComponent<ContactItemProps & React.RefAttributes<HTMLDivElement>> & {
    Title: React.ForwardRefExoticComponent<SpanAttributes & TypographyProps & React.RefAttributes<HTMLDivElement>>;
    Description: React.ForwardRefExoticComponent<SpanAttributes & TypographyProps & React.RefAttributes<HTMLDivElement>>;
};
