import type { AvatarIconProps } from '../Avatar/Avatar.types';
import type { Props } from '../_utils/types';
export interface ContactItemProps extends Props {
    /**
     * The avatar rich media url
     * @since 10.19.0
     */
    imageUrl?: string;
    /**
     * The icon to display
     * @since 10.19.0
     */
    icon?: AvatarIconProps['icon'];
    /**
     * Avatar text label
     */
    initials?: string;
    /**
     * Is the contact item selected
     * @defaultValue false
     * @since 10.19.0
     */
    selected?: boolean;
    /**
     * Is the contact item disabled
     * @defaultValue false
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * Is the contact item clickable
     * @defaultValue false
     * @since 10.19.0
     */
    clickable?: boolean;
}
