import React from 'react';
import type { DateSelectProps } from './DateSelect.types';
/**

 We use date selects to allow users to enter a date into a form by either
 selecting it from a calendar or typing it into a date field.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-dateselect--demo)

 @see [Design Guidelines](https://design.procore.com/date-select)

 */
export declare const DateSelect: React.ForwardRefExoticComponent<DateSelectProps & React.RefAttributes<HTMLDivElement>>;
