import type { CalendarProps } from '../Calendar/Calendar.types';
import type { DateInputProps } from '../DateInput/DateInput.types';
import type { OverlayTriggerProps } from '../OverlayTrigger/OverlayTrigger.types';
import type { VisibilityConfig } from '../_hooks/Visibility';
declare type PickedDateInputProps = Pick<DateInputProps, 'className' | 'disabled' | 'error' | 'onChange' | 'onClear' | 'tabIndex' | 'variant'>;
declare type PickedCalendarProps = Pick<CalendarProps, 'disabledDate'>;
declare type PickedOverlayTriggerProps = Pick<OverlayTriggerProps, 'beforeHide' | 'beforeShow'>;
declare type PickedVisibilityProps = Pick<VisibilityConfig, 'afterHide' | 'afterShow'>;
export interface DateSelectProps extends PickedDateInputProps, PickedOverlayTriggerProps, PickedVisibilityProps, PickedCalendarProps {
    /**
     * @since 10.19.0
     */
    value?: Date;
}
export {};
