import type { PageAsideProps, PageComponentProps, PageHeaderProps } from '../PageLayout/PageLayout.types';
import type { SectionProps } from '../Section/Section.types';
import type { Props } from '../_utils/types';
export declare type DetailPageWidth = 'md' | 'lg' | 'xl' | 'block';
export interface DetailPageProps extends Props {
    /**
     * @description Width of the content
     * @since 10.19.0
     */
    width?: DetailPageWidth;
    /**
     * @description If the page has anchor navigation
     * @since TBD
     */
    hasNavigation?: boolean;
}
export interface DetailPageAsideProps extends PageAsideProps {
}
export interface DetailPageHeaderProps extends PageHeaderProps {
}
export interface DetailPageSectionProps extends SectionProps {
}
export interface DetailPageCardProps extends PageComponentProps {
    navigationLabel?: string;
}
