import type { PageFooterTemplateProps } from '../PageTemplate/PageFooterTemplate';
import type { PageHeaderTemplateProps } from '../PageTemplate/PageHeaderTemplate';
import type { PageTemplateProps } from '../PageTemplate/PageTemplate';
import type { UsingProps } from '../_utils/types';
export declare type DetailPageHeaderTemplateProps = UsingProps<PageHeaderTemplateProps, 'breadcrumbs' | 'heading', 'actions' | 'banner' | 'pills' | 'subheading' | 'tabs' | 'toggleAction'>;
export declare type DetailPageFooterTemplateProps = UsingProps<PageFooterTemplateProps, 'actions', 'required' | 'notation'>;
export declare type DetailPageTemplateProps = Pick<PageTemplateProps, 'header' | 'footer' | 'pane' | 'children'> & {
    /**
     * @since 12.20.0
     */
    headerProps?: DetailPageHeaderTemplateProps;
    /**
     * @since 12.20.0
     */
    footerProps?: PageFooterTemplateProps;
    /**
     * @since 12.20.0
     */
    hasNavigation?: boolean;
};
