import React from 'react';
import { useOverlayTriggerContext } from '../OverlayTrigger/OverlayTrigger';
import type { ConsumerProps, DropdownButtonProps, DropdownProps } from './Dropdown.types';
export declare const DropdownButton: React.ForwardRefExoticComponent<DropdownButtonProps & React.RefAttributes<HTMLButtonElement>>;
export declare const useDropdownContext: typeof useOverlayTriggerContext;
export declare function DropdownConsumer({ children }: ConsumerProps): JSX.Element;
/**

 Dropdowns display a list of actions in a menu that opens and closes. We use
 dropdowns most commonly to trigger an action or to redirect the user to
 a new page or modal.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-dropdown--demo)

 @see [Design Guidelines](https://design.procore.com/dropdown)

*/
export declare const Dropdown: React.ForwardRefExoticComponent<DropdownProps & React.RefAttributes<HTMLButtonElement>> & {
    Item: import("../_utils/polymorphic").PolymorphicAs.ComponentWithForwardedRef<import("../MenuImperative/MenuImperative.types").MenuItemProps, import("../MenuImperative/MenuImperative.types").MenuItemDefaultElement>;
    Group: React.ForwardRefExoticComponent<import("..").DivAttributes & import("../MenuImperative/MenuImperative.types").GroupProps & React.RefAttributes<HTMLDivElement>>;
};
