import React from 'react';
import type { DropdownFlyoutProps, FlyoutCaptionProps, FlyoutItemProps, FlyoutListProps } from './DropdownFlyout.types';
export declare const FlyoutCaption: React.ForwardRefExoticComponent<FlyoutCaptionProps & React.RefAttributes<HTMLDivElement>>;
export declare function FlyoutItem({ option }: FlyoutItemProps): React.JSX.Element;
export declare function FlyoutList({ options, placement, referenceEl, overlayRef: overlayElRef, offset, }: FlyoutListProps): React.JSX.Element;
/**

  The dropdown flyout allows for additional menu items to be nested within
  parent items, which allows more menu options for users.
  @a11y WARN: DropdownFlyotus hold no value and take an action. Focus is expected
    to be moved from a Dropdown to something else, to continue the user flow.
    If the action is inert and does not move focus, this is left to be added
    by the consumer.
  @since 10.19.0

  @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-dropdownflyout--demo)

  @see [Design Guidelines](https://design.procore.com/dropdown-flyout)

 */
export declare const DropdownFlyout: React.ForwardRefExoticComponent<DropdownFlyoutProps & React.RefAttributes<HTMLDivElement>>;
