import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { DropzoneContentProps, DropzoneErrorBannerProps, DropzoneProps, DropzoneRef, MultipleErrorsProps } from './Dropzone.types';
export declare function MultipleErrors(props: MultipleErrorsProps): React.JSX.Element;
export declare const DropzoneErrorBanner: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<DropzoneErrorBannerProps & DivAttributes & React.RefAttributes<HTMLDivElement>>, any, {}, never>;
export declare function DropzoneDefaultMessage({ open, disabled, multiple, errorMessage, }: DropzoneContentProps & {
    multiple: boolean;
}): React.JSX.Element;
/**

 Dropzones allow users to quickly upload files from their computers, as well
 as optionally launch the file select component.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-dropzone--demo)

 @see [Design Guidelines](https://design.procore.com/dropzone)

*/
export declare const Dropzone: React.MemoExoticComponent<React.ForwardRefExoticComponent<DropzoneProps & React.RefAttributes<DropzoneRef>>>;
