import React from 'react';
import type { DivAttributes, ImgAttributes, Props } from '../_utils/types';
import type { EmptyStateImageProps, EmptyStateProps } from './EmptyState.types';
/**

 We place empty states on pages where nothing has been created yet.
 They tell the user what they need to know about the page and how to get
 started creating or using the page’s main features.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-emptystate--demo)

 @see [Design Guidelines](https://design.procore.com/empty-state)

*/
export declare const EmptyState: React.ForwardRefExoticComponent<DivAttributes & EmptyStateProps & React.RefAttributes<HTMLDivElement>> & {
    Actions: React.ForwardRefExoticComponent<DivAttributes & Props & React.RefAttributes<HTMLDivElement>>;
    Description: React.ForwardRefExoticComponent<{
        as?: "div" | "p" | undefined;
    } & DivAttributes & Props & React.RefAttributes<HTMLDivElement>>;
    Image: React.ForwardRefExoticComponent<ImgAttributes & DivAttributes & EmptyStateImageProps & React.RefAttributes<HTMLDivElement>>;
    NoItems: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    NoItemsWithoutCreatePermissions: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    NoResults: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    RecycleBin: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Title: React.ForwardRefExoticComponent<DivAttributes & Props & React.RefAttributes<HTMLDivElement>>;
};
