import type { Props } from '../_utils/types';
declare type EmptyStateStatus = 'noItems' | 'imageChild' | 'noItemsNoPermissions' | 'noResults' | 'recycleBin';
export declare const emptyState: Record<EmptyStateStatus, string>;
export declare type EmptyStateSize = 'sm' | 'md' | 'lg';
export interface EmptyStateProps extends Props {
    /**
     * Render the EmptyState in compact mode
     * @since 10.19.0
     * @deprecatedSince 12.18.0
     * @deprecated compact has been deprecated and will be removed in a future version
     */
    compact?: boolean;
    /**
     * Sets the EmptyState's elements layout
     * @since 12.18.0
     */
    isHorizontal?: boolean;
    /**
     * Sets the EmptyState's size
     * @defaultValue lg
     * @since 12.18.0
     */
    size?: EmptyStateSize;
}
export interface EmptyStateActionsProps extends Props {
}
export interface EmptyStateDescriptionsProps extends Props {
}
export interface EmptyStateImageProps {
    /**
     * @since 10.19.0
     */
    src?: string;
}
export interface EmptyStateTitleProps extends Props {
}
export {};
