import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { FileListItemProps, FileListProps } from './FileList.types';
export declare const defaultGetViewUrl: (item: FileListItemProps) => string | undefined;
export declare const defaultGetDownloadUrl: (item: FileListItemProps) => string | undefined;
export declare const defaultGetName: (item: FileListItemProps) => string;
/**

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-filelist--demo)

 @see [Design Guidelines](https://design.procore.com/file-list)

 */
export declare const FileList: React.ForwardRefExoticComponent<FileListProps & DivAttributes & React.RefAttributes<HTMLDivElement>>;
export declare function Item({ name, viewUrl, downloadUrl, ...props }: FileListItemProps): React.JSX.Element;
