interface QaTags {
    /**
     * @since 10.19.0
     */
    item?: (item: FileListItemProps) => string;
}
export interface FileListItemProps {
    /**
     * @since 10.19.0
     */
    name: string;
    /**
     * @since 10.19.0
     */
    downloadUrl?: string;
    /**
     * @since 10.22.0
     */
    viewUrl?: string;
}
export interface FileListProps {
    /**
     * "Download All" link URL
     * @since 10.19.0
     */
    downloadAllUrl?: string;
    /**
     * @since 10.19.0
     */
    items: FileListItemProps[];
    /**
     * @since 10.19.0
     */
    qa?: QaTags;
    /**
     * A function returning file list item's view URL
     * @since 10.22.0
     */
    getViewUrl?: (item: FileListItemProps) => string;
    /**
     * A function returning file list item's download URL
     * @since 10.22.0
     */
    getDownloadUrl?: (item: FileListItemProps) => string;
    /**
     * A function returning file list item's name
     * @since 10.22.0
     */
    getName?: (item: FileListItemProps) => string;
}
export {};
