function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
import { StyledNavigation, StyledSidebar, StyledSourceItem } from './FileExplorerSidebar.styles';
import { useSidebarNavigation } from './useSidebarNavigation';
export function FileExplorerSidebar(_ref) {
  var selectedSource = _ref.value,
    onChange = _ref.onChange,
    sources = _ref.sources,
    isOpen = _ref.isOpen;
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    isNavFocused = _React$useState2[0],
    setIsNavFocused = _React$useState2[1];
  var _React$useState3 = React.useState(true),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    isFocusVisible = _React$useState4[0],
    setIsFocusVisible = _React$useState4[1];
  var focusedSourceRef = React.useRef(null);
  var selectedSourceIndex = sources.findIndex(function (_ref2) {
    var sourceId = _ref2.sourceId;
    return sourceId === selectedSource;
  });
  var sidebarNavigation = useSidebarNavigation({
    initialIndex: selectedSourceIndex,
    size: sources.length,
    selectedIndex: selectedSourceIndex
  });
  React.useEffect(function () {
    sidebarNavigation.set(selectedSourceIndex);
  }, [selectedSourceIndex]);
  React.useEffect(function () {
    if (focusedSourceRef.current && isOpen) {
      focusedSourceRef.current.focus();
    }
  }, [sidebarNavigation.index, isOpen]);
  React.useEffect(function () {
    sidebarNavigation.setSize(sources.length);
  }, [sources.length]);
  var onKeyDown = function onKeyDown(e) {
    if (!isNavFocused) return;
    switch (e.nativeEvent.key) {
      case 'Enter':
        e.preventDefault();
        onChange(sources[sidebarNavigation.index].sourceId);
        break;
      case 'ArrowUp':
      case 'Up':
        e.preventDefault();
        sidebarNavigation.up();
        break;
      case 'ArrowDown':
      case 'Down':
        e.preventDefault();
        sidebarNavigation.down();
        break;
    }
  };
  return /*#__PURE__*/React.createElement(StyledSidebar, null, /*#__PURE__*/React.createElement(StyledNavigation, null, sources.map(function (source, idx) {
    var isFocused = idx === sidebarNavigation.index;
    return /*#__PURE__*/React.createElement(StyledSourceItem, {
      key: source.sourceId,
      loading: source.isUploading,
      error: source.hasError,
      icon: source.icon,
      selected: selectedSource === source.sourceId,
      focused: isNavFocused && isFocusVisible && isFocused,
      tabIndex: isFocused ? 0 : -1,
      ref: isFocused ? focusedSourceRef : null,
      onMouseDown: function onMouseDown() {
        // prevent focus blink on the latest focused item
        setIsFocusVisible(false);
      },
      onMouseUp: function onMouseUp() {
        setIsFocusVisible(true);
      },
      count: source.value.length,
      onFocus: function onFocus() {
        setIsNavFocused(true);
      },
      onBlur: function onBlur() {
        setIsNavFocused(false);
      },
      onKeyDown: onKeyDown,
      onClick: function onClick() {
        sidebarNavigation.set(idx);
        onChange(source.sourceId);
      }
    }, source.title);
  })));
}
//# sourceMappingURL=FileExplorerSidebar.js.map