import React from 'react';
import type { PortalProps } from '../Portal/Portal.types';
import type { DivAttributes } from '../_utils/types';
import type { FileSelectContextApi, FileSelectProps, FileSelectRef } from './FileSelect.types';
export declare const FileSelectLocalSourceId = "FileSelectLocalSource";
declare type FileSelectDOMAttributes = Omit<DivAttributes, 'onError' | 'onProgress'>;
export declare const FileSelectContext: React.Context<FileSelectContextApi>;
export declare const useFileSelectContext: () => FileSelectContextApi;
/**

 The file explorer enables users to select permitted files from various document
 sources in procore to attach to items.

 @since 10.19.0

 @see [Storybook](https://procore.github.io/core/latest/?path=/story/demos-fileselect--demo)

 @see [Design Guidelines](https://design.procore.com/file-select)
 @see [New File Select Repo](https://github.com/procore/documents-js-monorepo/tree/main/packages/file-select)

 @deprecated
 This component has been removed from the system. The File Select base component is now managed in documents-js-monorepo.
 @deprecatedSince 11.23.3

 */
export declare const FileSelect: React.ForwardRefExoticComponent<FileSelectProps & FileSelectDOMAttributes & PortalProps & React.RefAttributes<FileSelectRef>> & {
    LocalSource: React.ForwardRefExoticComponent<import("./LocalSource/LocalSource.types").LocalSourceProps & React.RefAttributes<HTMLDivElement>>;
    GridSource: React.ForwardRefExoticComponent<import("./GridSource").GridSourceProps & DivAttributes & React.RefAttributes<HTMLDivElement>>;
    TreeSource: React.ForwardRefExoticComponent<import("./TreeSource/TreeSource.types").FileTreeProps & Omit<DivAttributes, "onChange"> & React.RefAttributes<import(".").TreeSourceRef>>;
};
export {};
