var _excluded = ["tokens", "onClick", "onClose", "qa", "onKeyDown"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { useListNavigation } from '../../_hooks/ListNavigation';
import { isFunction } from '../../_utils/isFunction';
import { StyledFileToken, StyledTokenList } from './FileTokenList.styles';
function noop() {}
function getProgress(_ref) {
  var progress = _ref.progress;
  return progress !== null && progress !== void 0 ? progress : 100;
}
function isUndefined(value) {
  return typeof value === 'undefined';
}
export var FileTokenList = /*#__PURE__*/React.forwardRef(function FileTokenList(_ref2, ref) {
  var tokens = _ref2.tokens,
    onClick = _ref2.onClick,
    _ref2$onClose = _ref2.onClose,
    _onClose = _ref2$onClose === void 0 ? noop : _ref2$onClose,
    qa = _ref2.qa,
    onKeyDown = _ref2.onKeyDown,
    props = _objectWithoutProperties(_ref2, _excluded);
  var focusedTokenRef = React.useRef(null);
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    isListFocused = _React$useState2[0],
    setIsListFocused = _React$useState2[1];
  var navigation = useListNavigation({
    circular: false,
    initialIndex: 0,
    size: tokens.length
  });
  React.useEffect(function () {
    navigation.setSize(tokens.length);
    if (tokens.length === 0) setIsListFocused(false);
  }, [navigation, tokens.length]);
  React.useEffect(function () {
    if (focusedTokenRef.current && isListFocused) {
      focusedTokenRef.current.focus();
    }
  }, [isListFocused, navigation]);
  var onKeyDownHandler = React.useCallback(function (e) {
    if (!isListFocused) return;
    var token = tokens[navigation.index];
    switch (e.key) {
      case 'Backspace':
      case 'Delete':
        e.preventDefault();
        if (!e.repeat) {
          _onClose(token);
          if (tokens.length >= 1) {
            navigation.set(Math.max(0, navigation.index - 1));
          }
        }
        break;
      case 'Space Bar':
      case ' ':
        e.preventDefault();
        var error = token.error;
        if (isUndefined(error) && getProgress(token) === 100) {
          onClick === null || onClick === void 0 ? void 0 : onClick(token);
        }
        break;
      case 'ArrowUp':
      case 'Up':
      case 'ArrowLeft':
      case 'Left':
        e.preventDefault();
        navigation.decrement();
        break;
      case 'ArrowDown':
      case 'Down':
      case 'ArrowRight':
      case 'Right':
        e.preventDefault();
        navigation.increment();
        break;
      default:
    }
    onKeyDown && onKeyDown(e);
  }, [isListFocused, navigation, onClick, _onClose, onKeyDown, tokens]);
  return /*#__PURE__*/React.createElement(StyledTokenList, _extends({}, props, {
    ref: ref,
    onFocus: function onFocus() {
      return setIsListFocused(true);
    },
    onBlur: function onBlur() {
      return setIsListFocused(false);
    },
    onKeyDown: onKeyDownHandler
  }), tokens.map(function (token, index) {
    var _qa$fileToken;
    var isFocused = navigation.index === index;
    return /*#__PURE__*/React.createElement(StyledFileToken, {
      "data-qa": qa === null || qa === void 0 ? void 0 : (_qa$fileToken = qa.fileToken) === null || _qa$fileToken === void 0 ? void 0 : _qa$fileToken.call(qa, token.id),
      qa: qa,
      key: token.id,
      ref: isFocused ? focusedTokenRef : null,
      tabIndex: isFocused ? 0 : -1,
      progressValue: getProgress(token),
      errorMessage: token.error,
      fileName: token.name,
      onFocus: function onFocus() {
        return navigation.set(index);
      },
      onLabelClick: isFunction(onClick) ? function () {
        return onClick(token);
      } : onClick,
      onClose: function onClose() {
        return _onClose(token);
      }
    });
  }));
});
FileTokenList.displayName = 'FileTokenList';
//# sourceMappingURL=FileTokenList.js.map