function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { VisuallyHidden } from '@react-aria/visually-hidden';
import throttle from 'lodash.throttle';
import React from 'react';
import { useI18nContext } from '../../_hooks/I18n';
var getInfo = function getInfo(items, uploadProgress) {
  var info = items.reduce(function (acc, item) {
    var _uploadProgress$item$;
    if (item.error) {
      return _objectSpread(_objectSpread({}, acc), {}, {
        failed: acc.failed + 1
      });
    }
    var progress = (_uploadProgress$item$ = uploadProgress[item.id]) !== null && _uploadProgress$item$ !== void 0 ? _uploadProgress$item$ : 0;
    var totalProgress = acc.totalProgress + progress;
    var uploaded = progress === 100 ? acc.uploaded + 1 : acc.uploaded;
    return _objectSpread(_objectSpread({}, acc), {}, {
      totalProgress: totalProgress,
      uploaded: uploaded
    });
  }, {
    totalProgress: 0,
    failed: 0,
    uploaded: 0
  });
  return _objectSpread(_objectSpread({}, info), {}, {
    total: items.length,
    // 33.3333333333% => 33%
    totalProgress: Math.round(info.totalProgress / items.length)
  });
};
export var ProgressAnnouncer = function ProgressAnnouncer(_ref) {
  var items = _ref.items,
    uploadProgress = _ref.uploadProgress,
    _ref$throttleMs = _ref.throttleMs,
    throttleMs = _ref$throttleMs === void 0 ? 5000 : _ref$throttleMs;
  var i18n = useI18nContext();
  var _React$useState = React.useState(''),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    announce = _React$useState2[0],
    setAnnounce = _React$useState2[1];
  // Needed to not announce two times that progress is 100%
  var isAllUploadedAnnounced = React.useRef(false);
  var updateAnnounce = function updateAnnounce(files) {
    var info = getInfo(files, uploadProgress);
    var totalProgressAnnounce = info.failed ? i18n.t('core.dropzone.uploadTotalProgress.withFailed', info) : i18n.t('core.dropzone.uploadTotalProgress.withoutFailed', info);
    setAnnounce(totalProgressAnnounce);
  };
  var updateAnnounceThrottled = React.useCallback(throttle(updateAnnounce, throttleMs,
  // After file selection VoiceOver announces - the current location is the browser window.
  // It takes some time.
  {
    leading: false
  }), [throttleMs]);
  React.useEffect(function () {
    isAllUploadedAnnounced.current = false;
  }, [items.length]);
  React.useEffect(function () {
    if (items.length > 0) {
      var isAllUploaded = items.every(function (item) {
        return uploadProgress[item.id] === 100;
      });
      if (isAllUploaded && !isAllUploadedAnnounced.current) {
        // announce immediately
        isAllUploadedAnnounced.current = true;
        updateAnnounceThrottled.cancel();
        updateAnnounce(items);
      } else if (!isAllUploaded) {
        updateAnnounceThrottled(items);
      }
    }
  }, [items, uploadProgress]);
  React.useEffect(function () {
    return function () {
      updateAnnounceThrottled.cancel();
    };
  }, []);
  return announce ? /*#__PURE__*/React.createElement(MemoizedAnnouncer, {
    value: announce
  }) : null;
};
var Announcer = function Announcer(_ref2) {
  var value = _ref2.value;
  return /*#__PURE__*/React.createElement(VisuallyHidden, null, /*#__PURE__*/React.createElement("div", {
    role: "status"
  }, value));
};
var MemoizedAnnouncer = /*#__PURE__*/React.memo(Announcer);
//# sourceMappingURL=ProgressAnnouncer.js.map