import type { DivAttributes } from '../../_utils/types';
declare type ThumbnailId = string | number;
export interface ThumbnailListItem {
    /**
     * @since 10.19.0
     */
    id: ThumbnailId;
    /**
     * @since 10.19.0
     */
    name: string;
    /**
     * @since 10.19.0
     */
    src?: File | string;
    /**
     * @since 10.19.0
     */
    error?: string;
    /**
     * @since 10.19.0
     */
    response?: unknown;
}
export interface ThumbnailListProps extends Omit<DivAttributes, 'children'> {
    /**
     * @since 10.19.0
     */
    items: ThumbnailListItem[];
    /**
     * @since 10.19.0
     */
    onCancel?: (item: ThumbnailListItem) => void;
    /**
     * @since 10.19.0
     */
    listHeight?: number;
    /**
     * @since 10.19.0
     */
    rowHeight?: number;
}
export {};
