import * as React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { FlexProps } from './Flex.types';
/**
 * `Flex` is a wrapper around `Box` defaulting to display flex CSS
 * and providing shorter prop names (e.g. `shrink` instead of `flexShrink`).
 * `Box` can mimic anything `Flex` can.
 */
export declare const Flex: React.ForwardRefExoticComponent<DivAttributes & FlexProps & React.RefAttributes<HTMLDivElement>>;
