import type { FlexDirection, FlexOptions, FlexWrap, MarginOptions, MarginSize, PaddingOptions } from '../Box/Box.types';
import type { Props } from '../_utils/types';
export interface FlexProps extends Props, FlexOptions, MarginOptions, PaddingOptions {
    /**
     * @default 'row'
     * @since 10.19.0
     */
    direction?: FlexDirection;
    /**
     * @default false
     * @since 10.19.0
     */
    inline?: boolean;
    /**
     * @since 10.19.0
     */
    flex?: string;
    /**
     * @since 10.19.0
     */
    basis?: string;
    /**
     * @since 10.19.0
     */
    grow?: string;
    /**
     * @since 10.19.0
     */
    shrink?: string;
    /**
     * @since 10.19.0
     */
    tabIndex?: number;
    /**
     * @since 10.19.0
     */
    wrap?: FlexWrap;
    /**
     * @since 10.19.0
     */
    order?: number;
    /**
     * @since 11.3.0
     */
    gap?: MarginSize | string;
}
