import React from 'react';
import type { DivAttributes } from '../_utils/types';
import type { FlexListProps } from './FlexList.types';
/**
 * `FlexList` combines `Flex` and `Box`, **each child element is wrapped in a `Box`**
 * having a margin (leading and trailing space removed). This isolates the
 * children React components from the `display: flex` on direct children in CSS.
 */
export declare const FlexList: React.ForwardRefExoticComponent<DivAttributes & FlexListProps & React.RefAttributes<HTMLDivElement>>;
