import type { BoxProps, MarginSize } from '../Box/Box.types';
import type { FlexProps } from '../Flex/Flex.types';
export interface FlexListProps extends FlexProps {
    /**
     * Props to apply to each Box that wraps each child.
     * @since 10.19.0
     */
    boxProps?: BoxProps;
    /**
     * Margin on a single item. Between two items, `size` is double the distance of `space`.
     * @since 10.19.0
     */
    size?: MarginSize;
    /**
     * Total margin between items. Between two items, `space` is half the distance of `size`.
     * @since 10.19.0
     */
    space?: MarginSize;
}
