import React from 'react';
import { Form } from '../../index';
import type { PillColor } from '../../Pill';
export declare function FormDebugger(props?: any): React.JSX.Element;
interface SingleFormProps {
    component?: any;
    debug?: boolean;
    initialValue?: any;
    variant?: React.ComponentProps<typeof Form>['variant'];
    view?: React.ComponentProps<typeof Form>['view'];
    useLabelAsInlineLabel?: boolean;
    useDescriptionAsInlineDescription?: boolean;
}
interface DemoFormProps {
    view?: React.ComponentProps<typeof Form>['view'];
    enableConfirmNavigation?: React.ComponentProps<typeof Form>['enableConfirmNavigation'];
}
export declare const DemoForm: ({ view, enableConfirmNavigation, }: DemoFormProps) => React.JSX.Element;
/** All variations for a field. views, with values, no values, text variations, etc.
 * @example
 *  <BaseCRU
      component={Form.Number}
      initialValue={100}
    />
 */
export declare function BaseCRU<Element extends React.JSXElementConstructor<any>>(props: Omit<SingleFormProps, 'component'> & {
    component: Element;
} & Omit<React.ComponentProps<Element>, 'name'>): React.JSX.Element;
export declare const formGroupSelectOptions: {
    id: number;
    label: string;
}[];
export declare const formGroupSelectGroups: {
    options: ({
        id: number;
        label: string;
    } | undefined)[];
    id: number;
    label: string;
}[];
export declare const formTieredSelectOptions: ({
    id: number;
    groupId: null;
    nextGroupId: number;
    label: string;
} | {
    id: number;
    groupId: number;
    nextGroupId: number;
    label: string;
} | {
    id: number;
    groupId: number;
    label: string;
    nextGroupId?: undefined;
})[];
export declare const formSelectOptions: {
    id: number;
    label: string;
    groupAssociation: number;
}[];
export declare const formSelectGroupOptions: {
    uuid: number;
    displayName: string;
}[];
export declare const formPillSelectOptions: {
    id: string;
    label: string;
    color: PillColor;
}[];
export declare const formInitialValues: {
    text: string;
    number: number;
    checkbox: boolean;
    checkboxes: {
        id: number;
        label: string;
        groupAssociation: number;
    }[];
    currency: number;
    date: Date;
    textarea: string;
    select: {
        id: number;
        label: string;
        groupAssociation: number;
    };
    multiselect: {
        id: number;
        label: string;
        groupAssociation: number;
    }[];
    pillselect: {
        id: string;
        label: string;
        color: PillColor;
    };
    groupselect: {
        id: number;
        label: string;
    }[];
    tieredselect: ({
        id: number;
        groupId: null;
        nextGroupId: number;
        label: string;
    } | {
        id: number;
        groupId: number;
        nextGroupId: number;
        label: string;
    })[];
    radiobuttons: {
        id: number;
        label: string;
        groupAssociation: number;
    };
    richtext: string;
};
export {};
