import type { ColorPaletteObject } from '../_styles/colors';
import type { Props } from '../_utils/types';
declare type Shape = 'default' | 'round';
export interface GhostPlaceholderProps extends Props {
    /**
     * Possible shapes are 'default' and 'round'
     * @default 'default'
     * @since 12.11.0
     */
    shape?: Shape;
    /**
     * Will display smaller version of the placeholder instead of full width
     * @default 'false'
     * @since 12.11.0
     */
    small?: boolean;
    /**
     * The starting color of the gradient
     * @default gray94
     * @since 12.11.0
     */
    startGradientColor?: ColorPaletteObject | string;
    /**
     * The ending color of the gradient
     * @default gray20
     * @since 12.11.0
     */
    endGradientColor?: ColorPaletteObject | string;
}
export interface PlaceholderItemProps {
    $startGradientColor?: GhostPlaceholderProps['startGradientColor'];
    $endGradientColor?: GhostPlaceholderProps['endGradientColor'];
}
export interface RoundPlaceholderItemProps extends PlaceholderItemProps {
    $small?: boolean;
}
export {};
