import React from 'react';
import type { MultiSelectProps } from '../MultiSelect/MultiSelect.types';
import type { GroupSelectProps } from './GroupSelect.types';
/**

 Group select allows users to select multiple options from a single item in a
 menu. Other select components are multi select, and select, tiered select.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-groupselect--custom-search)

 @see [Design Guidelines](https://design.procore.com/group-select)

 */
export declare const GroupSelect: React.ForwardRefExoticComponent<GroupSelectProps & React.RefAttributes<HTMLDivElement & MultiSelectProps>>;
