import type { Props } from '../_utils/types';
export declare type ControlVariant = 'align-right' | 'block' | 'search';
export interface DivProps extends Props {
}
export interface ListPageProps extends Props {
}
export interface ListPageControlProps extends Props {
    /**
     * Controls whether the contents will align to the right
     * @since 10.19.0
     */
    alignRight?: boolean;
    /**
     * Controls whether the contents will attmpt to span the full width
     * @since 10.19.0
     */
    block?: boolean;
    /**
     * Sets width to a specific size for Search to fit
     * @since 10.19.0
     */
    search?: boolean;
    /**
     * @deprecated please use the equivalent boolean prop instead
     * @deprecatedSince 11
     * @since 10.19.0
     */
    variant?: ControlVariant;
}
