import React from 'react';
/**
 *  Tracks the children of the modal, primarily for managing focus
 */
interface ChildRegistry {
    header?: React.RefObject<HTMLDivElement>;
    body?: React.RefObject<HTMLDivElement>;
    closeableButtons?: React.RefObject<HTMLDivElement>;
}
interface ChildToRegister {
    child: keyof ChildRegistry;
    ref: React.MutableRefObject<null>;
}
export declare function ChildRegistryProvider({ children, }: {
    children: React.ReactNode;
}): React.JSX.Element;
export declare function useModalChildRegistryContext(): ChildRegistry;
export declare function useModalChildRegistryDispatch(): React.Dispatch<ChildToRegister>;
export {};
