import React from 'react';
import type { NextMenuProps } from './NextMenu.types';
/**
 * Count items in groups by id received from getItemGroupId
 *
 * @param items_
 * @param groups_
 * @param getItemGroupId
 * @return number[]
 * */
export declare const getGroupCounts: (items_: any[], groups_: any[], getItemGroupId: (item: any) => string | number) => number[];
/**
 Menus are used in conjunction with components that contain dropdowns.
 For example, multi select, single select, and dropdown.

 @since 11.1.1
 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_coverage-nextmenu--with-groups)
 @see [Design Guidelines](https://design.procore.com/menu)
 */
export declare const NextMenu: React.ForwardRefExoticComponent<NextMenuProps<any, any> & React.RefAttributes<React.ReactElement<any, string | React.JSXElementConstructor<any>>>>;
/**
 * Flat version of menu list
 * */
export declare const NextMenuFlat: React.ForwardRefExoticComponent<NextMenuProps<any, any> & {
    totalListHeightChanged: (height: number) => void;
} & React.RefAttributes<React.ReactElement<any, string | React.JSXElementConstructor<any>>>>;
/**
 * Grouped version of menu list
 * Provide getItemGroupId to group items
 * @see getGroupCounts
 * */
export declare const NextMenuGrouped: React.ForwardRefExoticComponent<NextMenuProps<any, any> & {
    totalListHeightChanged: (height: number) => void;
} & React.RefAttributes<React.ReactElement<any, string | React.JSXElementConstructor<any>>>>;
