function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["style"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
// TODO figure out what to do with this component RE SuperSelect
import React from 'react';
import { GroupedVirtuoso, Virtuoso } from 'react-virtuoso';
import { defaultMenuHeight, optionMinHeight, StyledOptions } from './NextMenu.styles';
import { NextMenuGroup, NextMenuItem } from './NextMenuItem';

/**
 * Count items in groups by id received from getItemGroupId
 *
 * @param items_
 * @param groups_
 * @param getItemGroupId
 * @return number[]
 * */
export var getGroupCounts = function getGroupCounts(items_, groups_, getItemGroupId) {
  return groups_.map(function (group) {
    var groupedItems = items_.filter(function (item) {
      return getItemGroupId(item) === group.id;
    });
    return groupedItems.length;
  });
};

/**
 * Get the height of the item list, used to make menu grow to size of item list
 * (or to a max height if applied by implementer) with a minimum of 32px
 * @param height;
 * @returns number
 */
function calculateHeight(height) {
  return Math.max(height, optionMinHeight);
}
var Options = /*#__PURE__*/React.forwardRef(function (props, ref) {
  return /*#__PURE__*/React.createElement(StyledOptions, _extends({
    ref: ref
  }, props));
});
var flatComponents = {
  Item: NextMenuItem,
  List: Options
};
var groupedComponents = {
  Group: NextMenuGroup,
  Item: NextMenuItem,
  List: Options
};

/**
 Menus are used in conjunction with components that contain dropdowns.
 For example, multi select, single select, and dropdown.

 @since 11.1.1
 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_coverage-nextmenu--with-groups)
 @see [Design Guidelines](https://design.procore.com/menu)
 */
export var NextMenu = /*#__PURE__*/React.forwardRef(function (_ref, menuRef) {
  var _props$groups;
  var style = _ref.style,
    props = _objectWithoutProperties(_ref, _excluded);
  var _React$useState = React.useState(defaultMenuHeight),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    adjustedHeight = _React$useState2[0],
    setAdjustedHeight = _React$useState2[1];
  var sharedMenuConfiguration = {
    ref: menuRef,
    style: _objectSpread({
      height: adjustedHeight,
      minHeight: optionMinHeight
    }, style),
    totalListHeightChanged: function totalListHeightChanged(height) {
      return setAdjustedHeight(calculateHeight(height));
    }
  };
  if (!((_props$groups = props.groups) !== null && _props$groups !== void 0 && _props$groups.length)) {
    return /*#__PURE__*/React.createElement(NextMenuFlat, _extends({}, sharedMenuConfiguration, props));
  }
  return /*#__PURE__*/React.createElement(NextMenuGrouped, _extends({}, sharedMenuConfiguration, props));
});

/**
 * Flat version of menu list
 * */
export var NextMenuFlat = /*#__PURE__*/React.forwardRef(function (_ref2, menuRef) {
  var _ref2$items = _ref2.items,
    items = _ref2$items === void 0 ? [] : _ref2$items,
    _ref2$overscan = _ref2.overscan,
    overscan = _ref2$overscan === void 0 ? 20 : _ref2$overscan,
    style = _ref2.style,
    totalListHeightChanged = _ref2.totalListHeightChanged,
    _ref2$onEndReached = _ref2.onEndReached,
    onEndReached = _ref2$onEndReached === void 0 ? function () {} : _ref2$onEndReached,
    _ref2$components = _ref2.components,
    components = _ref2$components === void 0 ? {} : _ref2$components,
    _ref2$getItemLabel = _ref2.getItemLabel,
    getItemLabel = _ref2$getItemLabel === void 0 ? function (item) {
      return item === null || item === void 0 ? void 0 : item.label;
    } : _ref2$getItemLabel;
  return /*#__PURE__*/React.createElement(Virtuoso, {
    ref: menuRef,
    components: _objectSpread(_objectSpread({}, flatComponents), components),
    context: {
      items: items,
      getItemLabel: getItemLabel
    },
    data: items,
    overscan: overscan,
    style: style,
    totalListHeightChanged: totalListHeightChanged,
    endReached: onEndReached
  });
});

/**
 * Grouped version of menu list
 * Provide getItemGroupId to group items
 * @see getGroupCounts
 * */
export var NextMenuGrouped = /*#__PURE__*/React.forwardRef(function (props, menuRef) {
  var children = props.children,
    _props$components = props.components,
    components = _props$components === void 0 ? {} : _props$components,
    _props$items = props.items,
    items = _props$items === void 0 ? [] : _props$items,
    _props$groups2 = props.groups,
    groups = _props$groups2 === void 0 ? [] : _props$groups2,
    _props$getItemGroupId = props.getItemGroupId,
    getItemGroupId = _props$getItemGroupId === void 0 ? function () {
      return -1;
    } : _props$getItemGroupId,
    _props$overscan = props.overscan,
    overscan = _props$overscan === void 0 ? 20 : _props$overscan,
    onSelect_ = props.onSelect,
    _props$onEndReached = props.onEndReached,
    onEndReached_ = _props$onEndReached === void 0 ? function () {} : _props$onEndReached,
    style = props.style,
    totalListHeightChanged = props.totalListHeightChanged;
  var groupCounts = getGroupCounts(items, groups, getItemGroupId);
  return /*#__PURE__*/React.createElement(GroupedVirtuoso, {
    ref: menuRef,
    style: style,
    components: _objectSpread(_objectSpread({}, groupedComponents), components),
    context: {
      items: items
    },
    groupCounts: groupCounts,
    overscan: overscan,
    endReached: onEndReached_,
    totalListHeightChanged: totalListHeightChanged
  });
});
//# sourceMappingURL=NextMenu.js.map