import type { CurrencyDisplay } from '@procore/globalization-toolkit';
import React from 'react';
import type { CurrencyInputProps, CurrencyProps, NumberInputProps } from './NumberInput.types';
/**

 The number input allows users to add numbers to a given form or table.
 The currency input will be used for data with a monetary value.
 Both components allow characters 0-9, periods, and commas. In order to avoid
 the loss of precision, the number length is limited by 15 digits.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-numberinput--demo-number-input)

 @see [Design Guidelines](https://design.procore.com/number-and-currency-input)

 */
export declare const NumberInput: React.ForwardRefExoticComponent<NumberInputProps & React.RefAttributes<HTMLInputElement>>;
export declare const getCurrencyProps: (locale: string, _decimalScale: NumberInputProps['decimalScale'], symbol?: string, currencyIsoCode?: string, currencyDisplay?: CurrencyDisplay) => CurrencyProps;
export declare const CurrencyInput: React.ForwardRefExoticComponent<CurrencyInputProps & React.RefAttributes<HTMLInputElement>>;
