import React from 'react';
import type { Placement } from '../_utils/placement';
import type { OverlayTriggerProps } from './OverlayTrigger.types';
/**

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-overlaytrigger--demo)

 */
export declare const OverlayTrigger: React.ForwardRefExoticComponent<OverlayTriggerProps & React.RefAttributes<HTMLElement>>;
export declare function CloseOnFocus({ hide }: {
    hide: (event: any) => any;
}): React.JSX.Element;
export declare function useOverlayTriggerContext(): {
    hide: (event: any) => any;
    show: (event: any) => any;
    toggle: (event: any) => any;
};
interface TriggerOverlayProps {
    containFocus?: boolean;
    autoFocus?: boolean;
    restoreFocus?: boolean;
    placement: Placement;
    canFlip?: boolean;
    arrow?: boolean;
    padding: number;
    shrinkOverlay: boolean;
    overlay: React.ReactNode;
    overlayCloneProps: any;
    wrapperProps: Record<string, unknown>;
    referenceElement: HTMLElement | null;
}
export declare const TriggerOverlay: React.ForwardRefExoticComponent<TriggerOverlayProps & React.RefAttributes<HTMLElement>>;
export {};
