import type React from 'react';
import type { AnchorNavigationSection } from '../AnchorNavigation/AnchorNavigation.types';
import type { DivAttributes, Props, UlAttributes } from '../_utils/types';
interface CustomizableStyledComponent {
    as?: string | React.ComponentType<any>;
}
export interface PageComponentProps extends CustomizableStyledComponent, Props, DivAttributes {
}
export interface PageBodyNavigationProps extends Props, Omit<UlAttributes, 'onSelect'> {
    sections?: AnchorNavigationSection[];
    selected?: string;
    onSelect?: (id: string) => void;
    minSections?: number;
}
export interface PageHeaderProps extends PageComponentProps {
    /**
     * @description If the header should have no background.
     * @since 10.19.0
     */
    transparent?: boolean;
}
export interface PageAsideProps extends PageComponentProps {
    /**
     * @description If the aside block should be open
     * @since 10.19.0
     */
    open?: boolean;
}
export interface PageMainProps extends PageComponentProps {
}
export interface PageFooterProps extends PageComponentProps {
}
export declare type PageAsideAnimationStatus = 'open' | 'closed' | 'opening' | 'closing';
export {};
