function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
import { useResizeObserver } from '../../_hooks/ResizeObserver';
import { useCurrentMedia } from '../../_hooks/useCurrentMedia';
var contentGap = 16;
var pixelsToNumber = function pixelsToNumber(value) {
  return Number(value.slice(0, -2));
};

/**
 * Returns `true` if first block collides with second block in the container, `false` otherwise
 * */
var checkCollision = function checkCollision(container, firstBlock, secondBlock) {
  var containerWidth = pixelsToNumber(getComputedStyle(container).width);
  var firstBlockWidth = pixelsToNumber(getComputedStyle(firstBlock).width);
  var secondBlockWidth = pixelsToNumber(getComputedStyle(secondBlock).width);
  return firstBlockWidth + contentGap + secondBlockWidth >= containerWidth;
};
export var usePageHeaderTemplateLayout = function usePageHeaderTemplateLayout() {
  var _useCurrentMedia = useCurrentMedia(),
    isTabletLandscape = _useCurrentMedia.isTabletLandscape,
    isDesktop = _useCurrentMedia.isDesktop;
  var headerRef = React.useRef(null);
  var breadcrumbsWrapperRef = React.useRef(null);
  var breadcrumbsRef = React.useRef(null);
  var actionsRef = React.useRef(null);
  var headingRef = React.useRef(null);
  var _React$useState = React.useState('top'),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    actionsPosition = _React$useState2[0],
    setActionsPosition = _React$useState2[1];
  var handleResize = React.useCallback(function () {
    var header = headerRef.current;
    var breadcrumbsWrapper = breadcrumbsWrapperRef.current;
    var breadcrumbs = breadcrumbsRef.current;
    var actions = actionsRef.current;
    if (!header || !actions) {
      return;
    }
    if (!breadcrumbs || !breadcrumbsWrapper) {
      var heading = headingRef.current;
      if (!heading) {
        return;
      }
      if (isDesktop || isTabletLandscape) {
        if (actionsPosition === 'bottom') {
          setActionsPosition('top');
        }
        return;
      }
      var _hasCollision = checkCollision(header, heading, actions);
      if (actionsPosition === 'top' && _hasCollision) {
        setActionsPosition('bottom');
        return;
      }
      if (actionsPosition === 'bottom' && !_hasCollision) {
        setActionsPosition('top');
      }
      return;
    }
    var hasCollision = checkCollision(breadcrumbsWrapper, breadcrumbs, actions);
    if (actionsPosition === 'top' && hasCollision) {
      setActionsPosition('bottom');
      return;
    }
    if (actionsPosition === 'bottom' && !hasCollision) {
      setActionsPosition('top');
    }
  }, [actionsPosition, isDesktop, isTabletLandscape]);
  var observe = useResizeObserver(handleResize);
  React.useEffect(function () {
    observe(headerRef.current);
  }, [observe]);
  return {
    headerRef: headerRef,
    breadcrumbsWrapperRef: breadcrumbsWrapperRef,
    breadcrumbsRef: breadcrumbsRef,
    actionsRef: actionsRef,
    headingRef: headingRef,
    actionsPosition: actionsPosition
  };
};
//# sourceMappingURL=PageHeaderTemplate.utils.js.map