import React from 'react';
import { usePageTemplateContext } from '../PageTemplate/usePageTemplateContext';
import { StyledModal, StyledPageAside } from './PagePaneTemplate.styles';
export var PagePaneTemplate = /*#__PURE__*/React.forwardRef(function PagePane(props, ref) {
  var labelId = props.labelId,
    open = props.open,
    onClose = props.onClose,
    children = props.children;
  var _usePageTemplateConte = usePageTemplateContext(),
    isMobile = _usePageTemplateConte.isMobile;
  if (isMobile) {
    return /*#__PURE__*/React.createElement(StyledModal, {
      ref: ref,
      "aria-labelledby": labelId,
      open: open,
      onClickOverlay: onClose,
      placement: "center",
      role: "dialog",
      width: "md"
    }, children);
  }
  return /*#__PURE__*/React.createElement(StyledPageAside, {
    ref: ref,
    open: open
  }, children);
});
//# sourceMappingURL=PagePaneTemplate.js.map