var _excluded = ["children", "header", "footer", "pane", "innerPane"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { AnchorNavigationProvider } from '../../AnchorNavigation/AnchorNavigationProvider';
import { breakpointRawMinWidthValues } from '../../Grid/Grid.constants';
import { Page } from '../../PageLayout';
import { useMediaLessThan } from '../../_hooks/useMediaLessThan';
import { mergeRefs } from '../../_utils/mergeRefs';
import { StyledPageBody, StyledPageBodyWrapper, StyledPageWrapper } from './PageTemplate.styles';
import { PageTemplateContext } from './PageTemplateContext';
export var PageTemplate = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var children = _ref.children,
    header = _ref.header,
    footer = _ref.footer,
    pane = _ref.pane,
    innerPane = _ref.innerPane,
    props = _objectWithoutProperties(_ref, _excluded);
  var mainRef = React.useRef(null);
  var isMobile = useMediaLessThan(mainRef, breakpointRawMinWidthValues.tabletMd);
  return /*#__PURE__*/React.createElement(AnchorNavigationProvider, null, /*#__PURE__*/React.createElement(PageTemplateContext.Provider, {
    value: {
      isMobile: isMobile
    }
  }, /*#__PURE__*/React.createElement(Page, _extends({
    "data-core-react": "page-template"
  }, props, {
    ref: mergeRefs(ref, mainRef)
  }), /*#__PURE__*/React.createElement(StyledPageWrapper, null, header, /*#__PURE__*/React.createElement(StyledPageBodyWrapper, null, /*#__PURE__*/React.createElement(Page.Main, null, (innerPane || children) && /*#__PURE__*/React.createElement(StyledPageBody, null, innerPane, children), footer), pane)))));
});
//# sourceMappingURL=PageTemplate.js.map