import React from 'react';
import type { PresetPaginationProps } from './Pagination.types';
/**

 We paginate pages that display large data sets to our users. This helps reduce
 page load time and makes the data easier to navigate.

 Pagination is commonly seen on tool landing pages, where we display 150 objects
 or table rows per page.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/demos-pagination--demo)

 @see [Design Guidelines](https://design.procore.com/pagination)

 */
export declare const Pagination: React.ForwardRefExoticComponent<PresetPaginationProps & React.RefAttributes<HTMLDivElement>>;
