/// <reference types="react" />
import type { ButtonProps } from '../Button/Button.types';
import type { SectionProps } from '../Section/Section.types';
import type { ButtonAttributes, DivAttributes } from '../_utils/types';
export interface PanelQaTags {
    /**
     * @since 10.19.0
     */
    moreIcon?: string;
    /**
     * @since 10.19.0
     */
    title?: string;
}
export interface PanelProps extends DivAttributes {
}
export interface PanelHeaderProps extends DivAttributes {
    /**
     * Controls visibility and behavior for the "chevron-left" icon on the left
     * side of the title.
     * @since 10.19.0
     */
    onClickBack?: () => void;
    /**
     * @since 10.19.0
     */
    onClose?: () => void;
}
export interface PanelTitleTooltipProps {
    /**
     * @since 10.19.0
     */
    children: React.ReactNode;
    /**
     * @since 10.19.0
     */
    isVisible: boolean;
    /**
     * @since 10.19.0
     */
    overlay: React.ReactNode;
}
export interface PanelHeaderActionProps extends ButtonAttributes, ButtonProps {
    /**
     * Tooltip/Overflow menu label text.
     * @since 10.19.0
     * */
    title: string;
}
export interface PanelBodyProps extends DivAttributes {
    /**
     * Applies the gray secondary background color.
     * @since 10.19.0
     */
    secondaryBgColor?: boolean;
}
export interface PanelContextShape {
    /**
     * @since 12.11.2
     */
    isScrolling: boolean;
    /**
     * @since 12.11.2
     * */
    setIsScrolling: (value: boolean) => void;
}
export interface PanelSectionProps extends SectionProps {
}
