/// <reference types="react" />
export declare type PillColor = 'blue' | 'cyan' | 'gray' | 'green' | 'magenta' | 'red' | 'UNSAFE_orange' | 'yellow';
export interface PillProps extends React.ComponentPropsWithoutRef<'span'> {
    /**
     * Controls the border, background and color of the Pill
     * @defaultValue gray
     * @since 10.19.0
     */
    color?: PillColor;
    /**
     * It is possible for this component to have an empty value
     * (render placeholder). Enables the x icon.
     * ```
     * (event) => {}
     * ```
     * @since 11.13.1
     */
    onClear?: (event: React.MouseEvent<SVGElement, MouseEvent>) => void;
}
