import React from 'react';
import type { PillOption, PillSelectProps } from './PillSelect.types';
export declare function defaultGetColor(option: PillOption): import("..").PillColor;
/**

 Pill Selects are used when you need a user to select between one of several
 options that are shown as pills. Often this will be a status, such as marking
 an item “closed”, “draft”, etc.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-pillselect--demo)

 @see [Design Guidelines](https://design.procore.com/pill-select)

 */
export declare const PillSelect: React.ForwardRefExoticComponent<PillSelectProps<any, any> & React.RefAttributes<HTMLDivElement>>;
