import React from 'react';
import type { ProgressBarProps } from './ProgressBar.types';
/**

 Progress bars visually show system loading progress, such as uploading a file
 or loading a page, as well as user progress, like filling out a form.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-progressbar--demo)

 @see [Design Guidelines](https://design.procore.com/progress-bar)

 @a11y Please use an `aria-label`. The `aria-label` value should not include the term "Progress Bar" as a role already identifies it as such

 */
export declare const ProgressBar: React.ForwardRefExoticComponent<ProgressBarProps & React.RefAttributes<HTMLDivElement>>;
