var _excluded = ["animated", "value"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { clamp, maxProgressValue, minProgressValue } from '../Loader/Loader';
import { StyledProgressBar, StyledProgressBarLoader } from './ProgressBar.styles';
var finalAnimationDuration = 900;

/**

 Progress bars visually show system loading progress, such as uploading a file
 or loading a page, as well as user progress, like filling out a form.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-progressbar--demo)

 @see [Design Guidelines](https://design.procore.com/progress-bar)

 @a11y Please use an `aria-label`. The `aria-label` value should not include the term "Progress Bar" as a role already identifies it as such

 */
export var ProgressBar = /*#__PURE__*/React.forwardRef(function ProgressBar(_ref, ref) {
  var _ref$animated = _ref.animated,
    animated = _ref$animated === void 0 ? false : _ref$animated,
    value = _ref.value,
    props = _objectWithoutProperties(_ref, _excluded);
  var isProgressValueComplete = value >= maxProgressValue;
  var _React$useState = React.useState(false),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    isFinalized = _React$useState2[0],
    setFinalized = _React$useState2[1];
  var _React$useState3 = React.useState(isProgressValueComplete),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    isProgressComplete = _React$useState4[0],
    setProgressComplete = _React$useState4[1];
  var didMountRef = React.useRef(false);
  React.useEffect(function () {
    var isFinalized = didMountRef.current && isProgressValueComplete;
    var timerId = isFinalized ? window.setTimeout(function () {
      setFinalized(false);
    }, finalAnimationDuration) : null;
    setProgressComplete(isProgressValueComplete);
    setFinalized(isFinalized);
    if (!didMountRef.current) {
      didMountRef.current = true;
    }
    return function () {
      timerId && clearTimeout(timerId);
    };
  }, [isProgressValueComplete]);
  var clampedValue = clamp(value);
  return /*#__PURE__*/React.createElement(StyledProgressBar, _extends({
    $complete: isProgressComplete,
    $finalized: isFinalized,
    ref: ref,
    role: "progressbar",
    "aria-valuenow": clampedValue,
    "aria-valuemin": minProgressValue,
    "aria-valuemax": maxProgressValue
  }, props, {
    "aria-valuetext": typeof props['aria-valuetext'] === 'function' ? props['aria-valuetext']({
      value: clampedValue
    }) : props['aria-valuetext']
  }), /*#__PURE__*/React.createElement(StyledProgressBarLoader, {
    value: value,
    animated: animated
  }));
});
ProgressBar.displayName = 'ProgressBar';
//# sourceMappingURL=ProgressBar.js.map