import type { LoaderProps } from '../Loader/Loader.types';
import type { DivAttributes } from '../_utils/types';
declare type ValueTextRender = (props: {
    value: number;
}) => string;
export interface ProgressBarProps extends LoaderProps, Omit<DivAttributes, 'aria-valuetext'> {
    /**
     * @a11y Assistive technologies often present the value of `aria-valuenow` as a percentage.
     * If this would not be accurate, use this property to make the progress bar value understandable.
     *
     * @since 11.8.0
     */
    ['aria-valuetext']?: string | ValueTextRender;
}
export {};
