import React from 'react';
import type { RadioButtonProps } from './RadioButton.types';
/**

 We use radio buttons to allow users to select a single, exclusive option from
 a list of multiple options.

 To present options in a dropdown, use a single select.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-radiobutton--demo)

 @see [Design Guidelines](https://design.procore.com/radio-button)

 */
export declare const RadioButton: React.ForwardRefExoticComponent<React.InputHTMLAttributes<HTMLInputElement> & RadioButtonProps & React.RefAttributes<HTMLInputElement>>;
