/// <reference types="react" />
import type { Props } from '../_utils/types';
export interface RequiredProps extends Props {
    /**
     * If provided, takes the place of label normally reading "required fields"
     * @since 10.19.0
     */
    children?: React.ReactNode;
    /**
     * Changes where I18n looks for the requiredFields key
     * @since 10.19.0
     */
    i18nScope?: string;
    /**
     * Controls showing text reading "required fields"
     * @since 10.19.0
     */
    showLabel?: boolean;
}
