import type React from 'react';
import type { DivAttributes, Placement, Props } from '../_utils/types';
/**
 * @deprecated Please use the `active` and `disabled` props
 * @deprecatedSince 11
 */
export declare const segmentedControllerSegmentVariant: {
    readonly active: "active";
    readonly disabled: "disabled";
    readonly none: "";
};
export interface SegmentedControllerProps extends Props, Omit<DivAttributes, 'onChange'> {
    /**
     * The segment is active
     * @since 10.19.0
     * @deprecated The property is not used anywhere
     * @deprecatedSince 12.18.0
     * */
    active?: number;
    /**
     * The segment controller is block sized
     * @since 10.19.0
     */
    block?: boolean;
    /**
     * Disables all segments in the controller
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * A callback to be called when the radio group value changes
     * @since 10.19.0
     */
    onChange?: (selected: number) => void;
    /**
     * @deprecated Please use the `block` prop
     * @deprecatedSince 11
     * @since 10.19.0
     */
    variant?: 'block' | '';
}
export interface SegmentedControllerSegmentProps extends Props {
    /**
     * The segment is active
     * @since 10.19.0
     * @deprecated Use `selected` instead
     * @deprecatedSince 12.18.0
     */
    active?: boolean;
    /**
     * Is the segment disabled
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * To change the tooltip placement
     * @since 10.19.0
     */
    placement?: Placement;
    /**
     * The segment is selected
     * @since 12.18.0
     * */
    selected?: boolean;
    /**
     * The tooltip we want to display on hover
     * @since 10.19.0
     */
    tooltip?: React.ReactNode;
}
export interface SegmentedControllerTooltipProps extends Props {
    /**
     * @since 10.19.0
     */
    overlay?: any;
    /**
     * @since 10.19.0
     */
    placement: Placement;
}
