import React from 'react';
import type { HeadingProps, ListProps } from './Semantic.types';
export declare const H1: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export declare const H2: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export declare const H3: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export declare const H4: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export declare const H5: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
export declare const H6: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<HTMLHeadingElement>>;
/**
 * @param level 1 - 6
 * @returns H1 - H6 component
 */
export declare function getHeadingComponent(level: string | number): React.ForwardRefExoticComponent<HeadingProps>;
export declare const P: React.ForwardRefExoticComponent<React.HTMLAttributes<HTMLParagraphElement> & React.RefAttributes<HTMLParagraphElement>>;
export declare const UL: React.ForwardRefExoticComponent<ListProps & React.RefAttributes<HTMLUListElement>>;
export declare const OL: React.ForwardRefExoticComponent<ListProps & React.RefAttributes<HTMLOListElement>>;
export declare const Label: React.ForwardRefExoticComponent<React.HTMLAttributes<HTMLLabelElement> & {
    htmlFor?: string | undefined;
    block?: boolean | undefined;
} & React.RefAttributes<HTMLLabelElement>>;
