import type { PageFooterTemplateProps } from '../PageTemplate/PageFooterTemplate';
import type { PageHeaderTemplateProps } from '../PageTemplate/PageHeaderTemplate';
import type { PageTemplateProps } from '../PageTemplate/PageTemplate';
import type { UsingProps } from '../_utils/types';
export declare type SettingsPageHeaderTemplateProps = UsingProps<PageHeaderTemplateProps, 'breadcrumbs' | 'heading', 'actions' | 'banner' | 'pills' | 'subheading' | 'tabs'>;
export declare type SettingsPageFooterTemplateProps = UsingProps<PageFooterTemplateProps, 'actions', 'required' | 'notation'>;
export declare type SettingsPageTemplateProps = Pick<PageTemplateProps, 'header' | 'footer' | 'children'> & {
    /**
     * @since 12.20.0
     */
    headerProps?: SettingsPageHeaderTemplateProps;
    /**
     * @since 12.20.0
     */
    footerProps?: SettingsPageFooterTemplateProps;
    /**
     * @since 12.20.0
     */
    hasNavigation?: boolean;
};
