import React from 'react';
import type { SliderProps } from './Slider.types';
export declare const getIncrements: ({ min, max, step, }: {
    min: number;
    max: number;
    step?: number | undefined;
}) => number;
export declare const getPercentage: ({ max, min, value, }: {
    max: number;
    min: number;
    value: number;
}) => number;
export declare const getLabel: ({ max, min, step, index, }: {
    max: number;
    min: number;
    step: number;
    index: number;
}) => number;
export declare const getDefaultValue: ({ min, max, step, }: {
    min: number;
    max: number;
    step?: number | undefined;
}) => number;
/**

 A slider is a bar with selectable/grabbable handle. It allows users to click
 and drag horizontally to a desired value. It is used when users need to select
 a value from a predefined range of values. Sliders should always have a
 corresponding value or increment displayed within proximity of the component.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-slider--demo)

 @see [Design Guidelines](https://design.procore.com/slider)

 */
export declare const Slider: React.ForwardRefExoticComponent<SliderProps & React.RefAttributes<HTMLInputElement>>;
