import type { InputAttributes } from '../_utils/types';
export interface SliderProps extends InputAttributes {
    /**
     * Whether or not to put the slider into a disabled state.
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * The maximum value of the slider (right side)
     * @defaultValue 100
     * @since 10.19.0
     */
    max?: number;
    /**
     * The minimum value of the slider (left side)
     * @defaultValue 0
     * @since 10.19.0
     */
    min?: number;
    /**
     * Whether or not to show value labels below the slider increments.
     * @since 10.19.0
     */
    showLabel?: boolean;
    /**
     * The distance between each stopping point on the Slider.
     * @defaultValue 1
     * @since 10.19.0
     */
    step?: number;
    /**
     * The currently set value of the Slider.
     * Defaults to the middle between min and max.
     * @defaultValue (max < min) ? min : min + (max - min)/2;
     * @since 10.19.0
     */
    value?: number;
}
