import React from 'react';
import type { Props } from '../_utils/types';
import type { SplitViewCardProps } from './SplitViewCard.types';
export declare const Main: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const Panel: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const PanelHeading: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const PanelTitle: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const PanelHeader: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const PanelBody: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
export declare const PanelFooter: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
/**

 A SplitViewCard component is used to display additional details
 of an item from a collection inside a panel of a card.

 - SplitViewCard
   - SplitViewCard.Main
     - SplitViewCard.Section
       - Table or some other main content
   - SplitViewCard.Panel
     - SplitViewCard.PanelHeader
       - SplitViewCard.PanelTitle
         - text
       - Tabs
     - SplitViewCard.PanelBody
       - Content
     - SplitViewCard.PanelFooter
       - SplitViewCard.Actions

 @since 12.9.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/demos-splitviewcard--demo)

 */
export declare const SplitViewCard: React.ForwardRefExoticComponent<SplitViewCardProps & React.RefAttributes<HTMLDivElement>> & {
    Actions: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Main: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Section: React.ForwardRefExoticComponent<import("../Section").SectionProps & React.RefAttributes<HTMLDivElement>>;
    Panel: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    PanelTitle: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    PanelHeader: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    PanelBody: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    PanelFooter: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
};
