import type { Props } from '../_utils/types';
export interface SplitViewCardInternalContextAPI {
    /**
     * Indicates whether the SplitViewCard can be closed
     * @deprecated dont support this feature
     * @deprecatedSince 12.20.5
     * */
    isClosable?: boolean;
    /**
     * Indicates whether the user is actively scrolling within the SplitViewCard.Body
     * @since 12.9.0
     */
    isScrolling: boolean;
    /**
     * Callback to update the isScrolling flag
     * @since 12.9.0
     */
    setIsScrolling: (isScrolling: boolean) => void;
}
export interface SplitViewCardContextAPI {
    /**
     * If SplitViewCard is open or not
     * @since 12.20.5
     */
    isOpen: boolean;
    /**
     * Show SplitViewCard
     * @since 12.20.5
     */
    show: () => void;
    /**
     * Hide SplitViewCard
     * @since 12.20.5
     */
    hide: () => void;
}
export interface SplitViewCardProps extends Props {
    /**
     * Indicates whether the SplitViewCard can be closed
     * @deprecated dont support this feature
     * @deprecatedSince 12.20.5
     * */
    isClosable?: boolean;
    /**
     * If aside card is initially opened or not
     * @since 12.9.0
     */
    isInitiallyOpen?: boolean;
    /**
     * Callback for custom close event
     * @since 12.9.0
     * @deprecated dont support this feature
     * @deprecatedSince 12.20.5
     */
    onClose?: () => void;
}
