import React from 'react';
import type { SuperSelectConfig } from './SuperSelect.types';
export declare const InternalDragDropContext: React.Context<{
    isDraggingOver: boolean;
}>;
export declare const SuperSelect: React.ForwardRefExoticComponent<SuperSelectConfig & React.RefAttributes<{
    config: {
        block: boolean;
        disabled: boolean;
        draggable: boolean;
        emptyMessage: string;
        error: boolean | undefined;
        footer: React.ReactElement<any, string | React.JSXElementConstructor<any>> | undefined;
        header: React.ReactElement<any, string | React.JSXElementConstructor<any>> | undefined;
        placeholder: string | undefined;
        preset: import("./SuperSelect.types").SuperSelectPreset;
        presetProps: import("./SuperSelect.types").SuperSelectPresetProps | undefined;
        selectionStyle: "checkbox" | "highlight" | "checkmark";
        tabIndex: number;
        loading: boolean;
        multiple: boolean;
    };
    components: {
        Overlay: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<HTMLElement>>;
        SingleTrigger: (props: any) => React.JSX.Element;
        MultiTrigger: (props: any) => React.JSX.Element | null;
        TriggerContainer: React.ForwardRefExoticComponent<any> | React.FC<any>;
        Trigger: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<HTMLDivElement>>;
        Indicators: (props: any) => React.JSX.Element;
        Label: React.ForwardRefExoticComponent<{
            hoverable: boolean;
        } & React.RefAttributes<HTMLDivElement>>;
        Loading: () => React.JSX.Element;
        ArrowContainer: (props: any) => React.JSX.Element;
        Arrow: ({ up, down, left, right, width, height, border, }: any) => React.JSX.Element;
        Clear: () => React.JSX.Element;
        MultiInputContainer: (props: {
            children?: React.ReactNode;
        }) => React.JSX.Element;
        MultiInput: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
        MultiValue: (props: any) => React.JSX.Element;
        MultiValueContainer: (props: any) => React.JSX.Element;
        SearchContainer: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
        Search: (props: any) => React.JSX.Element;
        Header: (props: any) => React.JSX.Element;
        Footer: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<unknown>>;
        EmptyMessage: (props: any) => React.JSX.Element;
        Options: (props: {
            children?: React.ReactNode;
        } & import("..").DivAttributes) => React.JSX.Element;
        Group: (props: {
            children?: React.ReactNode;
        }) => React.JSX.Element;
        Item: React.ForwardRefExoticComponent<import("./SuperSelect.types").SuperSelectMenuItemProps & React.RefAttributes<HTMLDivElement>>;
        OptionGroupHeader: ({ optgroup }: any) => React.JSX.Element;
        OptionLabel: ({ option }: any) => React.JSX.Element;
        OptionContent: ({ option }: any) => React.JSX.Element;
        DraggableOptionContent: ({ index, option }: any) => React.JSX.Element;
        DragHandle: (props: any) => React.JSX.Element;
        CheckboxContainer: (props: any) => React.JSX.Element;
        Checkbox: (props: any) => React.JSX.Element;
        CheckmarkContainer: (props: any) => React.JSX.Element;
        Checkmark: (props: any) => React.JSX.Element;
    };
    state: {
        activeMenuIndex: number | null;
        activeTokenIndex: number | null;
        isEmpty: () => boolean;
        listContainerHeight: number;
        listId: string;
        maxHeight: number;
        onDragEnd: (result: any) => void;
        onSelect: (option: any) => void;
        open: boolean;
        options: any[];
        overlayId: string;
        searchValue: string;
        selectedIndex: number;
        selectedLabel: string;
        selectedOption: any;
        setOpen: React.Dispatch<React.SetStateAction<boolean>>;
        setPointer: React.Dispatch<React.SetStateAction<boolean>>;
        setSearchValue: import("lodash").DebouncedFunc<React.Dispatch<React.SetStateAction<string>>>;
        sourceOptions: any[];
        value: import("./SuperSelect.types").SuperSelectValue;
        width: number;
    };
    props: {
        clear: () => {
            'aria-hidden': boolean;
            'aria-label': string;
            onClick(e: React.MouseEvent<Element, MouseEvent>): void;
        };
        emptyMessage: () => {
            emptyMessage: string;
        };
        footer: () => {
            ref: (el: HTMLElement | null) => void;
            onKeyDown: (e: React.KeyboardEvent<Element>) => void;
        };
        header: () => {
            ref: (el: HTMLElement | null) => void;
        };
        item: (userProps?: React.HTMLProps<HTMLElement> | undefined) => Record<string, unknown>;
        label: () => {
            $hoverable: boolean;
        };
        menu: () => {
            scrollable: boolean;
            style: {
                height: number;
            };
        };
        multiInput: () => React.AriaAttributes & React.InputHTMLAttributes<HTMLInputElement> & {
            ref: React.Ref<HTMLInputElement>;
        };
        overlay: (userProps?: React.HTMLProps<HTMLElement> | undefined) => Record<string, unknown>;
        search: () => {
            'aria-controls': string;
            onChange(value: string): void;
            placeholder: string;
        };
        searchContainer: () => {
            ref: (el: HTMLElement | null) => void;
        };
        tokenClear: (index: number) => {
            onClick(e: React.MouseEvent<Element, MouseEvent>): void;
        };
        trigger: (userProps?: React.HTMLProps<Element> | undefined) => Record<string, unknown>;
        virtuoso: () => import("react-virtuoso").VirtuosoProps<{}, {}>;
    };
    option: {
        group: (option: any) => string;
        isBatch: (option: any) => boolean;
        isSelected: (option: any) => boolean;
        isDisabled: (option: any) => boolean;
        isOptgroup: (item: any) => item is import("./SuperSelect.types").SuperSelectOptgroup;
        label: (option: any) => string;
        value: (option: any) => import("./SuperSelect.types").SuperSelectValuePrimitive;
    };
    refs: {
        floating: {
            placement: import("@floating-ui/utils").Placement;
            strategy: import("@floating-ui/utils").Strategy;
            middlewareData: import("@floating-ui/core").MiddlewareData;
            x: number;
            y: number;
            isPositioned: boolean;
            update: () => void;
            floatingStyles: React.CSSProperties;
            refs: {
                reference: React.MutableRefObject<import("@floating-ui/react-dom").ReferenceType | null>;
                floating: React.MutableRefObject<HTMLElement | null>;
                setReference: (node: import("@floating-ui/react-dom").ReferenceType | null) => void;
                setFloating: (node: HTMLElement | null) => void;
            } & import("@floating-ui/react").ExtendedRefs<HTMLElement>;
            elements: {
                reference: import("@floating-ui/react-dom").ReferenceType | null;
                floating: HTMLElement | null;
            } & import("@floating-ui/react").ExtendedElements<HTMLElement>;
            context: {
                x: number;
                y: number;
                placement: import("@floating-ui/utils").Placement;
                strategy: import("@floating-ui/utils").Strategy;
                middlewareData: import("@floating-ui/core").MiddlewareData;
                isPositioned: boolean;
                update: () => void;
                floatingStyles: React.CSSProperties;
                open: boolean;
                onOpenChange: (open: boolean, event?: Event | undefined) => void;
                events: import("@floating-ui/react").FloatingEvents;
                dataRef: React.MutableRefObject<import("@floating-ui/react").ContextData>;
                nodeId: string | undefined;
                floatingId: string;
                refs: import("@floating-ui/react").ExtendedRefs<HTMLElement>;
                elements: import("@floating-ui/react").ExtendedElements<HTMLElement>;
            };
        };
        navigationList: React.MutableRefObject<(HTMLElement | null)[]>;
        virtuoso: React.RefObject<import("react-virtuoso").VirtuosoHandle>;
    };
}>>;
