import React from 'react';
import type { InputAttributes } from '../_utils/types';
import type { SwitchProps } from './Switch.types';
/**

 We use switches to allow users to choose between two mutually exclusive choices
 in the same line. This is often associated with enabling vs. disabling.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-switch--demo)

 @see [Design Guidelines](https://design.procore.com/switch)

 */
export declare const Switch: React.ForwardRefExoticComponent<InputAttributes & SwitchProps & React.RefAttributes<HTMLInputElement>>;
