import React from 'react';
import type { CheckboxProps } from '../Checkbox/Checkbox.types';
import type { AnchorAttributes, DivAttributes, SpanAttributes, SVGAttributes, TableAttributes, TdAttributes, TextAreaAttributes, ThAttributes } from '../_utils/types';
import type { BodyCellProps, BodyProps, BodyRowProps, CaratProps, ContainerProps, CurrencyCellProps, DateSelectCellProps, GroupProps, GroupTitleProps, HeaderProps, HeaderRowProps, IconCellProps, InputCellProps, LinkCellProps, PercentCellProps, TableHeaderCellProps, TableProps, TableSelectCellProps, TableTextCellProps, TextAreaCellProps } from './Table.types';
export declare const Table_: React.ForwardRefExoticComponent<TableAttributes & TableProps & React.RefAttributes<HTMLTableElement>>;
export declare const Carat: React.ForwardRefExoticComponent<SVGAttributes & CaratProps & React.RefAttributes<HTMLDivElement>>;
export declare const Container: React.ForwardRefExoticComponent<DivAttributes & ContainerProps & React.RefAttributes<HTMLDivElement>>;
export declare const Header: React.ForwardRefExoticComponent<DivAttributes & HeaderProps & React.RefAttributes<HTMLTableSectionElement>>;
export declare const HeaderRow: React.ForwardRefExoticComponent<DivAttributes & HeaderRowProps & React.RefAttributes<HTMLTableRowElement>>;
export declare const HeaderCell: React.ForwardRefExoticComponent<ThAttributes & TableHeaderCellProps & React.RefAttributes<HTMLTableHeaderCellElement>>;
export declare const Body: React.ForwardRefExoticComponent<DivAttributes & BodyProps & React.RefAttributes<HTMLTableSectionElement>>;
export declare const Checkbox: React.ForwardRefExoticComponent<CheckboxProps & React.RefAttributes<HTMLInputElement>>;
export declare const GroupTitle: React.ForwardRefExoticComponent<SpanAttributes & GroupTitleProps & React.RefAttributes<HTMLSpanElement>>;
export declare const Group: React.ForwardRefExoticComponent<DivAttributes & GroupProps & React.RefAttributes<HTMLTableRowElement>>;
export declare const BodyRow: React.ForwardRefExoticComponent<DivAttributes & BodyRowProps & React.RefAttributes<HTMLTableRowElement>>;
export declare const BodyCell: React.ForwardRefExoticComponent<TdAttributes & BodyCellProps & React.RefAttributes<HTMLTableDataCellElement>>;
export declare const CurrencyCell: React.ForwardRefExoticComponent<DivAttributes & CurrencyCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const DateSelectCell: React.ForwardRefExoticComponent<DateSelectCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const IconCell: React.ForwardRefExoticComponent<DivAttributes & IconCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const InputCell: React.ForwardRefExoticComponent<InputCellProps & React.RefAttributes<HTMLInputElement>>;
export declare const LinkCell: React.ForwardRefExoticComponent<AnchorAttributes & LinkCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const PercentCell: React.ForwardRefExoticComponent<DivAttributes & PercentCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const SelectCell: React.ForwardRefExoticComponent<TableSelectCellProps & React.RefAttributes<HTMLDivElement>>;
export declare const TextAreaCell: React.ForwardRefExoticComponent<TextAreaAttributes & TextAreaCellProps & React.RefAttributes<HTMLTextAreaElement>>;
export declare const TextCell: React.ForwardRefExoticComponent<DivAttributes & TableTextCellProps & React.RefAttributes<HTMLDivElement>>;
/**

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-table--demo)

 */
export declare const Table: React.ForwardRefExoticComponent<TableAttributes & TableProps & React.RefAttributes<HTMLTableElement>> & {
    Body: React.ForwardRefExoticComponent<DivAttributes & BodyProps & React.RefAttributes<HTMLTableSectionElement>>;
    BodyCell: React.ForwardRefExoticComponent<TdAttributes & BodyCellProps & React.RefAttributes<HTMLTableDataCellElement>>;
    BodyRow: React.ForwardRefExoticComponent<DivAttributes & BodyRowProps & React.RefAttributes<HTMLTableRowElement>>;
    Carat: React.ForwardRefExoticComponent<SVGAttributes & CaratProps & React.RefAttributes<HTMLDivElement>>;
    Checkbox: React.ForwardRefExoticComponent<CheckboxProps & React.RefAttributes<HTMLInputElement>>;
    Container: React.ForwardRefExoticComponent<DivAttributes & ContainerProps & React.RefAttributes<HTMLDivElement>>;
    CurrencyCell: React.ForwardRefExoticComponent<DivAttributes & CurrencyCellProps & React.RefAttributes<HTMLDivElement>>;
    DateSelectCell: React.ForwardRefExoticComponent<DateSelectCellProps & React.RefAttributes<HTMLDivElement>>;
    Group: React.ForwardRefExoticComponent<DivAttributes & GroupProps & React.RefAttributes<HTMLTableRowElement>>;
    GroupTitle: React.ForwardRefExoticComponent<SpanAttributes & GroupTitleProps & React.RefAttributes<HTMLSpanElement>>;
    Header: React.ForwardRefExoticComponent<DivAttributes & HeaderProps & React.RefAttributes<HTMLTableSectionElement>>;
    HeaderCell: React.ForwardRefExoticComponent<ThAttributes & TableHeaderCellProps & React.RefAttributes<HTMLTableHeaderCellElement>>;
    HeaderRow: React.ForwardRefExoticComponent<DivAttributes & HeaderRowProps & React.RefAttributes<HTMLTableRowElement>>;
    IconCell: React.ForwardRefExoticComponent<DivAttributes & IconCellProps & React.RefAttributes<HTMLDivElement>>;
    InputCell: React.ForwardRefExoticComponent<InputCellProps & React.RefAttributes<HTMLInputElement>>;
    LinkCell: React.ForwardRefExoticComponent<AnchorAttributes & LinkCellProps & React.RefAttributes<HTMLDivElement>>;
    PercentCell: React.ForwardRefExoticComponent<DivAttributes & PercentCellProps & React.RefAttributes<HTMLDivElement>>;
    SelectCell: React.ForwardRefExoticComponent<TableSelectCellProps & React.RefAttributes<HTMLDivElement>>;
    TextAreaCell: React.ForwardRefExoticComponent<TextAreaAttributes & TextAreaCellProps & React.RefAttributes<HTMLTextAreaElement>>;
    TextCell: React.ForwardRefExoticComponent<DivAttributes & TableTextCellProps & React.RefAttributes<HTMLDivElement>>;
};
