import React from 'react';
import type { DivAttributes, Props, SpanAttributes } from '../_utils/types';
import type { BaseTabProps, TabDropdownProps, TabProps, TabRef, TabRole, TabRoleType, TabsProps } from './Tabs.types';
export declare const Link: React.ForwardRefExoticComponent<SpanAttributes & Props & {
    /** @deprecated @experimental Alternative style variant. To be used on Helix Header ONLY */
    UNSAFE_helixHeader?: boolean | undefined;
} & React.RefAttributes<HTMLSpanElement>>;
declare function TabInternal({ as, disabled, role, active, selected, children, onBlur, onFocus, onMount, onUnmount, overflowing, dropdown, variant, UNSAFE_helixHeader, ...props }: TabProps<TabRoleType>, ref: TabRef<TabRoleType>): React.JSX.Element;
export declare const Tab: <Role extends TabRole>(props: TabProps<Role> | (BaseTabProps & {
    ref?: React.ComponentPropsWithRef<'div'>['ref'];
})) => ReturnType<typeof TabInternal>;
export declare const MoreMenu: React.ForwardRefExoticComponent<DivAttributes & TabDropdownProps & React.RefAttributes<HTMLDivElement>>;
/**

 We use tabs to navigate between different, but related content.
 Tabs are commonly used on tool landing pages and on item detail pages.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-tabs--demo)

 @see [Design Guidelines](https://design.procore.com/tabs)

 */
export declare const Tabs: React.ForwardRefExoticComponent<DivAttributes & TabsProps & React.RefAttributes<HTMLDivElement>> & {
    Link: React.ForwardRefExoticComponent<SpanAttributes & Props & {
        /** @deprecated @experimental Alternative style variant. To be used on Helix Header ONLY */
        UNSAFE_helixHeader?: boolean | undefined;
    } & React.RefAttributes<HTMLSpanElement>>;
    Tab: <Role extends TabRole>(props: TabProps<Role> | (BaseTabProps & {
        ref?: React.ComponentPropsWithRef<'div'>['ref'];
    })) => ReturnType<typeof TabInternal>;
};
export {};
