import React from 'react';
import type { TearsheetContextProps, TearsheetProps } from './Tearsheet.types';
export declare const TearsheetContext: React.Context<TearsheetContextProps>;
/**

 The Tearsheet is a container for complex content placed over another layout,
 such as the Detail Page layout. They slide out from one direction on the screen.
 They allow users complete complex and detail rich tasks without leaving the page they were on.

 @since 10.25.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-tearsheet--demo)

  @see [Design Guidelines](https://design.procore.com/tearsheet)

 */
export declare const Tearsheet: (props: TearsheetProps & {
    /**
     * @deprecatedSince 11.11.0
     * @deprecated This ref is passed to two elements, in the future it will only be provided to the inner element (StyledTearsheetContent).
     */
    ref?: React.ComponentPropsWithRef<'div'>['ref'];
}) => React.ReactElement;
