import type { TextAreaAttributes } from '../_utils/types';
export interface TextAreaProps extends TextAreaAttributes {
    /**
     * Controls the error state of the `TextArea`, changing the
     * background color and border colors to red
     * @since 10.19.0
     */
    error?: boolean;
    /**
     * Controls the resize rules for the `TextArea`
     * @since 10.19.0
     * @see https://developer.mozilla.org/en-US/docs/Web/CSS/resize
     */
    resize?: 'both' | 'horizontal' | 'none' | 'vertical';
    /**
     * @deprecated
     * The `variant` prop has been deprecated and will be removed in a future version.
     * Please use the `error` boolean prop instead.
     *
     * **Before**
     *
     * `<TextArea variant="error" />`
     *
     * **After**
     *
     * `<TextArea error />`
     *
     * @deprecatedSince 10.20.0
     * @since 10.19.0
     */
    variant?: 'error' | '';
}
