import React from 'react';
import type { TextEditorProps, TextEditorProviderProps } from './TextEditor.types';
export declare function TextEditorProvider({ children, features, }: TextEditorProviderProps): React.JSX.Element;
/**

 We use text editors to allow users to enter multiple lines of formatted text.

 If users need to add unformatted text, see Text Area.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-texteditor--demo)

 @see [Design Guidelines](https://design.procore.com/text-editor)

 */
export declare function TextEditor({ error, init: initOverrides, locale, onChange, onInit: _onInit, plugins, ...props }: TextEditorProps): React.JSX.Element;
export declare namespace TextEditor {
    var displayName: string;
}
