function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["error", "init", "locale", "onChange", "onInit", "plugins"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
function _toConsumableArray(r) { return _arrayWithoutHoles(r) || _iterableToArray(r) || _unsupportedIterableToArray(r) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _iterableToArray(r) { if ("undefined" != typeof Symbol && null != r[Symbol.iterator] || null != r["@@iterator"]) return Array.from(r); }
function _arrayWithoutHoles(r) { if (Array.isArray(r)) return _arrayLikeToArray(r); }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
import { Editor } from '@tinymce/tinymce-react';
import React, { useState } from 'react';
import { useOverridableFocusScope } from '../_hooks/FocusScopeOverride';
import { useI18nContext } from '../_hooks/I18n';
import { useZIndexContext } from '../_hooks/ZIndex';
import { defaultPlugins, generateExternalPlugins, generateLanguageUrl, getValidLookupLocale, tinyMCEConfig, tinyMCESource, tinyMCETabMarkup, tinyMCEVersion } from '../_utils/TinyMCE';
import { GlobalStyle } from './TextEditor.styles';
var errorRed = '#E61920';
function noop() {}
var TextEditorContext = /*#__PURE__*/React.createContext({
  features: {
    tabAsNavigation: undefined,
    stickyToolbar: undefined
  }
});
export function TextEditorProvider(_ref) {
  var children = _ref.children,
    features = _ref.features;
  return /*#__PURE__*/React.createElement(TextEditorContext.Provider, {
    value: {
      features: features
    }
  }, children);
}
function setupDefaultShortcuts(editor) {
  editor.shortcuts.add('meta+shift+s', 'Strikethrough', 'Strikethrough');
}

/**
 * editor.addShortcut does not notify on Tab key presses
 */
function setupShortcuts(editor) {
  setupDefaultShortcuts(editor);
  editor.on('keydown', function checkTabPress(event) {
    if (event.altKey && event.key === 'Tab') {
      editor.execCommand('mceInsertContent', false, tinyMCETabMarkup);
      event.preventDefault();
      event.stopPropagation();
      return false;
    }
  });
}

/**
 * The following plugins open a TinyMCE modal.
 * When used with React Aria contained FocusScope,
 * focus does not move into the TinyMCE modal.
 * This patch gets critical functionality back at
 * the cost of possibly failing accessbility.
 */
function useFocusScopePatch(plugins) {
  var focusScope = useOverridableFocusScope();
  React.useEffect(function () {
    if ([].concat(_toConsumableArray(defaultPlugins), _toConsumableArray(plugins)).some(
    // Add plugins that open a tinymce modal here
    function (plugin) {
      return plugin === 'link' || plugin === 'table' || plugin === 'image';
    })) {
      focusScope.setProps({
        contain: false
      });
    }
  }, [focusScope, plugins]);
}

/**

 We use text editors to allow users to enter multiple lines of formatted text.

 If users need to add unformatted text, see Text Area.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-texteditor--demo)

 @see [Design Guidelines](https://design.procore.com/text-editor)

 */
export function TextEditor(_ref2) {
  var _props$initialValue, _props$value;
  var error = _ref2.error,
    initOverrides = _ref2.init,
    locale = _ref2.locale,
    _ref2$onChange = _ref2.onChange,
    onChange = _ref2$onChange === void 0 ? noop : _ref2$onChange,
    _onInit = _ref2.onInit,
    _ref2$plugins = _ref2.plugins,
    plugins = _ref2$plugins === void 0 ? defaultPlugins : _ref2$plugins,
    props = _objectWithoutProperties(_ref2, _excluded);
  var _useI18nContext = useI18nContext(),
    contextLocale = _useI18nContext.locale;
  var _useZIndexContext = useZIndexContext(),
    zIndex = _useZIndexContext.value;
  var _React$useContext = React.useContext(TextEditorContext),
    features = _React$useContext.features;
  var stickyToolbar = features !== null && features !== void 0 && features.stickyToolbar ? {
    toolbar_sticky: true
  } : {};
  var tabControls = features !== null && features !== void 0 && features.tabAsNavigation ? {
    external_plugins: generateExternalPlugins(plugins, defaultPlugins.filter(function (p) {
      return p !== 'nonbreaking';
    })),
    nonbreaking_force_tab: false,
    setup: setupShortcuts
  } : {
    setup: setupDefaultShortcuts
  };
  var onEditorChange = function onEditorChange(_, editor) {
    onChange(editor.getContent(), editor.isDirty());
  };
  var ref = React.useRef();
  var updateError = function updateError() {
    if (ref.current) {
      if (error) {
        ref.current.style.borderColor = errorRed;
      } else {
        ref.current.style.borderColor = '';
      }
    }
  };
  React.useEffect(function () {
    updateError();
  }, [error]);
  useFocusScopePatch(plugins);
  var onInit = function onInit(event, editor) {
    ref.current = editor.editorContainer;
    updateError();
    _onInit && _onInit(event, editor);
  };
  var _useState = useState((_props$initialValue = props.initialValue) !== null && _props$initialValue !== void 0 ? _props$initialValue : props.value),
    _useState2 = _slicedToArray(_useState, 1),
    derivedInitial = _useState2[0];

  // zIndex + 1 because on first render zIndex of Portal(Modal) is higher
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(GlobalStyle, {
    $zIndex: zIndex + 1
  }), /*#__PURE__*/React.createElement(Editor, _extends({
    init: _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, tinyMCEConfig), {}, {
      external_plugins: generateExternalPlugins(plugins),
      language_url: generateLanguageUrl(locale || contextLocale),
      language: getValidLookupLocale(locale || contextLocale),
      content_style: "p { margin: 0; }"
    }, stickyToolbar), tabControls), initOverrides),
    tinymceScriptSrc: "".concat(tinyMCESource, "/").concat(tinyMCEVersion, "/tinymce.min.js"),
    onInit: onInit,
    onEditorChange: onEditorChange
  }, props, {
    value: (_props$value = props.value) !== null && _props$value !== void 0 ? _props$value : props.initialValue,
    initialValue: derivedInitial
  })));
}
TextEditor.displayName = 'TextEditor';
//# sourceMappingURL=TextEditor.js.map