import type { IAllProps } from '@tinymce/tinymce-react';
import type { Props } from '../_utils/types';
export interface TextEditorOutputProps extends Omit<Props, 'children'> {
    /**
     * formatted text
     * @since 10.24.0
     * */
    value?: IAllProps['value'];
    /**
     * Config for when the editor is initialized.
     * **Changes after the editor has initialized are ignored.**
     * @link [TinyMCE React Init](https://www.tiny.cloud/docs/integrations/react/#init)
     * @since 11.17.0
     */
    init?: IAllProps['init'];
}
