function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["selected", "disabled", "clickable", "focused", "hasCaptionPlaceholder", "src", "filename", "size", "label", "name", "caption", "onChange", "value"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import { useCheckbox } from '@react-aria/checkbox';
import { useFocusRing } from '@react-aria/focus';
import { useRef } from 'react';
import { useToggleState } from 'react-stately';
import { getIsFilePreviewableAsImage } from './Thumbnail.utils';
var defaultSize = 'lg';
export var useThumbnail = function useThumbnail(_ref) {
  var selected = _ref.selected,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$clickable = _ref.clickable,
    clickable = _ref$clickable === void 0 ? true : _ref$clickable,
    _ref$focused = _ref.focused,
    focused = _ref$focused === void 0 ? false : _ref$focused,
    _ref$hasCaptionPlaceh = _ref.hasCaptionPlaceholder,
    hasCaptionPlaceholder = _ref$hasCaptionPlaceh === void 0 ? false : _ref$hasCaptionPlaceh,
    src = _ref.src,
    filename_ = _ref.filename,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? defaultSize : _ref$size,
    _ref$label = _ref.label,
    label = _ref$label === void 0 ? '' : _ref$label,
    name = _ref.name,
    _ref$caption = _ref.caption,
    caption = _ref$caption === void 0 ? '' : _ref$caption,
    onChange = _ref.onChange,
    value = _ref.value,
    props = _objectWithoutProperties(_ref, _excluded);
  var a11yProps = props.role === 'figure' ? {
    as: 'figure'
  } : {
    as: 'div'
  };
  var inputRef = useRef(null);
  var toggleState = useToggleState({
    defaultSelected: selected,
    onChange: onChange
  });
  var layout = size === 'sm' ? 'row' : 'column';
  var isFile = src instanceof File;
  var isImageURL = typeof src === 'string';
  var canPreviewFileAsImage = getIsFilePreviewableAsImage(src);
  var isFileOrNonPreviewableImage = isFile && !canPreviewFileAsImage;
  var shouldUsePlaceholder = isFileOrNonPreviewableImage || !src;
  var filename = filename_ !== null && filename_ !== void 0 ? filename_ : isFileOrNonPreviewableImage ? src.name : caption;
  var ariaLabel = label && caption ? "".concat(label, " ").concat(caption) : caption || label;
  var _useCheckbox = useCheckbox({
      isSelected: selected,
      'aria-label': ariaLabel,
      name: name,
      onChange: onChange,
      value: value
    }, toggleState, inputRef),
    inputProps = _useCheckbox.inputProps;
  var _useFocusRing = useFocusRing(),
    isFocusVisible = _useFocusRing.isFocusVisible,
    focusProps = _useFocusRing.focusProps;
  return _objectSpread(_objectSpread(_objectSpread({
    alt: props.alt || props.alt === '' ? props.alt : caption || label
  }, props), a11yProps), {}, {
    label: label,
    caption: caption,
    selected: toggleState.isSelected,
    disabled: disabled,
    clickable: clickable,
    focused: focused,
    isImageURL: isImageURL,
    hasCaptionPlaceholder: hasCaptionPlaceholder,
    shouldUsePlaceholder: shouldUsePlaceholder,
    src: src,
    filename: filename,
    size: size,
    layout: layout,
    inputRef: inputRef,
    inputProps: inputProps,
    /**
     * Appeared 23-1-18 https://github.com/procore/core/pull/12250
     * Possible issue with types from React Aria during dependency update
     * > The inferred type of 'useThumbnail' cannot be named without a
     * > reference to '@react-aria/focus/node_modules/@react-types/shared'.
     * > This is likely not portable. A type annotation is necessary.
     */
    focusProps: focusProps,
    isFocusVisible: isFocusVisible,
    toggleState: toggleState
  });
};
//# sourceMappingURL=Thumbnail.hooks.js.map