/// <reference types="react" />
import type { TypographyProps } from '../Typography';
import type { LayoutVariant, QaTags, SizeVariant } from './Thumbnail.types';
import { DocumentIcon } from './ThumbnailDocumentIcon';
interface CaptionProps {
    layout: LayoutVariant;
    error: boolean;
    disabled: boolean;
}
interface StyledThumbnailProps {
    focused: boolean;
    disabled: boolean;
    selected: boolean;
    clickable: boolean;
    size: SizeVariant;
}
interface StyledTickIconProps {
    selected: boolean;
    size: SizeVariant;
}
export declare const StyledMultilineCaption: import("styled-components").StyledComponent<"div", any, CaptionProps, never>;
export declare const StyledCaptionText: import("styled-components").StyledComponent<"span", any, {}, never>;
export declare const StyledPlaceholderCaption: import("styled-components").StyledComponent<"div", any, CaptionProps, never>;
export declare const StyledSingleLineCaption: import("styled-components").StyledComponent<"div", any, CaptionProps, never>;
export declare const StyledSinglelineCaptionBody: import("styled-components").StyledComponent<"span", any, {}, never>;
export declare const StyledSinglelineCaptionEnding: import("styled-components").StyledComponent<"span", any, {}, never>;
export declare const StyledLabelText: import("styled-components").StyledComponent<import("react").ForwardRefExoticComponent<import("..").SpanAttributes & TypographyProps & import("react").RefAttributes<HTMLSpanElement>>, any, {}, never>;
export declare const StyledThumbnailFigCaption: import("styled-components").StyledComponent<"figcaption", any, {
    $color?: TypographyProps['color'];
}, never>;
export declare const StyledLabel: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare const StyledTickIcon: import("styled-components").StyledComponent<"svg", any, StyledTickIconProps, never>;
export declare const StyledFileIcon: import("styled-components").StyledComponent<typeof DocumentIcon, any, {}, never>;
export declare const StyledImageThumbnailPreview: import("styled-components").StyledComponent<"div", any, {
    $bgImage: string;
}, never>;
export declare const StyledImageThumbnailOverlay: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare const StyledImageThumbnailImage: import("styled-components").StyledComponent<"img", any, {}, never>;
export declare const StyledImageThumbnail: import("styled-components").StyledComponent<"div", any, StyledThumbnailProps, never>;
export declare const StyledThumbnailWrapper: import("styled-components").StyledComponent<"div", any, {
    layout: LayoutVariant;
    size: SizeVariant;
    qa?: QaTags | undefined;
}, never>;
export declare const StyledPlaceholderThumbnail: import("styled-components").StyledComponent<"div", any, StyledThumbnailProps, never>;
export {};
