function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { getFileExtension } from '../_utils/filename';
export function getIsFilePreviewableAsImage(src) {
  return src instanceof File && src.type.startsWith('image/') &&
  // not allow previewing vendor image mime types, such as "image/vnd.adobe.photoshop"
  !src.type.startsWith('image/vnd.') &&
  // not allow previewing .tiff images, as a not browser-compatible format
  src.type !== 'image/tiff';
}
var extensions = _defineProperty(_defineProperty({
  image: ['png', 'jpg', 'jpeg', 'gif', 'psd', 'tiff', 'tif', 'bmp'],
  drawing: ['cad', 'dwg', 'dwf', 'dwfx'],
  email: ['msg', 'eml'],
  gantt: ['mpp', 'p6', 'xer'],
  zip: ['zip', 'rar', '7zip'],
  xml: ['rtf', 'txt'],
  word: ['doc', 'docx'],
  ini: ['ini', 'xml', 'exe'],
  mov: ['mov', 'avi'],
  pdf: ['pdf'],
  powerpoint: ['ppt', 'pptx'],
  excel: ['csv', 'xls', 'xlsx']
}, '3d', ['stl', 'obj', 'ma', 'fbx', 'dae', '3ds', 'iges', 'step', 'wrl', 'rvt', 'ifc', 'nwc', 'nwd', 'nwf']), "unknown", []);
var extensionsByVariant = Object.entries(extensions);
var variantByExtension = extensionsByVariant.reduce(function (acc, _ref) {
  var _ref2 = _slicedToArray(_ref, 2),
    type = _ref2[0],
    exts = _ref2[1];
  exts.forEach(function (ext) {
    acc[ext] = type;
  });
  return acc;
}, {});
export function getThumbnailVariantForFilename(filename) {
  var defaultUnknownName = 'unknown';
  try {
    var ext = getFileExtension(filename);
    return ext ? variantByExtension[ext] || defaultUnknownName : defaultUnknownName;
  } catch (_unused) {
    return defaultUnknownName;
  }
}
//# sourceMappingURL=Thumbnail.utils.js.map