function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
export var useGridNavigation = function useGridNavigation(_ref) {
  var initialIndicesRows = _ref.indicesRows;
  var _React$useState = React.useState(0),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    index = _React$useState2[0],
    setIndex = _React$useState2[1];
  var _React$useState3 = React.useState(initialIndicesRows),
    _React$useState4 = _slicedToArray(_React$useState3, 2),
    indicesRows = _React$useState4[0],
    setIndicesRows = _React$useState4[1];
  var _React$useState5 = React.useState(0),
    _React$useState6 = _slicedToArray(_React$useState5, 2),
    gridSize = _React$useState6[0],
    setGridSize = _React$useState6[1];
  React.useEffect(function () {
    setGridSize(indicesRows.flat().length);
  }, [indicesRows]);
  React.useEffect(function () {
    setIndex(function (prev) {
      return prev < gridSize ? prev : 0;
    });
  }, [gridSize]);
  var finalIndex = gridSize - 1;
  var up = function up(e) {
    e.preventDefault();
    var getNextIndex = function getNextIndex() {
      var rowIndex = indicesRows.findIndex(function (rowCells) {
        return rowCells.includes(index);
      });
      var nextRowIndex = rowIndex - 1;
      if (nextRowIndex < 0) {
        return indicesRows[rowIndex][0];
      }
      var nextRow = indicesRows[nextRowIndex];
      var nextCellIndex = indicesRows[rowIndex].findIndex(function (navigationIndex) {
        return navigationIndex === index;
      });
      var nextNavigationIndex = nextRow[nextCellIndex];
      return nextNavigationIndex !== null && nextNavigationIndex !== void 0 ? nextNavigationIndex : nextRow[nextRow.length - 1];
    };
    var nextIndex = getNextIndex();
    setIndex(nextIndex);
    return nextIndex;
  };
  var down = function down(e) {
    e.preventDefault();
    var getNextIndex = function getNextIndex() {
      var rowIndex = indicesRows.findIndex(function (rowCells) {
        return rowCells.includes(index);
      });
      var nextRowIndex = rowIndex + 1;
      var finalRowIndex = indicesRows.length - 1;
      if (nextRowIndex > finalRowIndex) {
        var row = indicesRows[rowIndex];
        return row[row.length - 1];
      }
      var nextRow = indicesRows[nextRowIndex];
      var nextCellIndex = indicesRows[rowIndex].findIndex(function (navigationIndex) {
        return navigationIndex === index;
      });
      var nextNavigationIndex = nextRow[nextCellIndex];
      return nextNavigationIndex !== null && nextNavigationIndex !== void 0 ? nextNavigationIndex : nextRow[nextRow.length - 1];
    };
    var nextIndex = getNextIndex();
    setIndex(nextIndex);
    return nextIndex;
  };
  var right = function right(e) {
    if (index === finalIndex) {
      return index;
    }
    e.preventDefault();
    var nextIndex = index + 1;
    if (nextIndex <= finalIndex) {
      setIndex(nextIndex);
    }
    return nextIndex;
  };
  var left = function left(e) {
    if (index === 0) {
      return index;
    }
    e.preventDefault();
    var nextIndex = index - 1;
    if (nextIndex >= 0) {
      setIndex(nextIndex);
    }
    return nextIndex;
  };
  return {
    index: index,
    setIndex: setIndex,
    setIndicesRows: setIndicesRows,
    up: up,
    down: down,
    left: left,
    right: right
  };
};
//# sourceMappingURL=ThumbnailGrid.hooks.js.map