import type React from 'react';
import type { ButtonProps, ButtonVariant } from '../Button/Button.types';
import type { TieredSelectProps } from '../TieredSelect';
declare type Div = React.ComponentPropsWithoutRef<'div'>;
declare type TriggerProps = Pick<ButtonProps, 'block' | 'disabled' | 'icon' | 'iconRight' | 'loading' | 'size'>;
export declare type SearchablePath<T = any> = {
    /**
     * @since 10.19.0
     */
    label: string;
    /**
     * @since 10.19.0
     */
    node: T;
    /**
     * @since 10.19.0
     */
    path: T[];
    /**
     * @since 10.19.0
     */
    pathKey: string;
};
export interface InternalTieredDropdownProps<T = any> extends Omit<Div, 'onSelect' | 'onChange'>, TriggerProps {
    /**
     * @since 10.19.0
     */
    children: React.ReactText;
    /**
     * @since 10.19.0
     */
    ['data-qa']?: string;
    /**
     * @since 10.19.0
     */
    options?: T[];
    /**
     * @since 10.19.0
     */
    value?: T[];
    /**
     * @since 10.19.0
     */
    variant?: ButtonVariant;
}
export interface TieredDropdownProps extends Omit<TieredSelectProps, 'onChange' | 'getValueString' | 'value'>, TriggerProps {
    /**
     * @since 10.19.0
     */
    onSelect: TieredSelectProps['onChange'];
    /**
     * @since 10.19.0
     */
    children: InternalTieredDropdownProps['children'];
    /**
     * @since 10.19.0
     */
    ['data-qa']?: string;
    /**
     * @since 10.19.0
     */
    variant?: InternalTieredDropdownProps['variant'];
}
export {};
