function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import { useCallback, useMemo, useState } from 'react';

// eslint-disable-next-line no-useless-escape
var periodDashAndWhitespaceRegex = /[\.\-\s]/g;
function matchString(value, searchQuery) {
  var lowerCasedKeyValue = value && value.toLowerCase() || '';
  var valueWithoutSeparators = lowerCasedKeyValue.replace(periodDashAndWhitespaceRegex, '');
  return valueWithoutSeparators.includes(searchQuery);
}
function matchKeyInObject(item, key, searchQuery) {
  if (typeof item[key] === 'string') {
    return matchString(item[key], searchQuery);
  }
  if (typeof item[key] === 'number') {
    return matchString("".concat(item[key]), searchQuery);
  }
  return false;
}
function filterCondition(item) {
  var searchTerm = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var keysToMatch = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : Object.keys(item);
  var lowerCasedSearchTerm = searchTerm.trim().toLowerCase();
  var sanitizedSearchQuery = lowerCasedSearchTerm.replace(periodDashAndWhitespaceRegex, '');
  return keysToMatch.some(function (key) {
    return matchKeyInObject(item, key, sanitizedSearchQuery);
  });
}
export function useSearch(config) {
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    searchTerm = _useState2[0],
    setSearchTerm = _useState2[1];
  var filteredItems = useMemo(function () {
    if (searchTerm === '') {
      return config.items;
    }
    return config.items.filter(function (item) {
      return filterCondition(item, searchTerm, config.keysToSearch);
    });
  }, [config, searchTerm]);
  var setSearch = useCallback(function (value) {
    setSearchTerm(value);
  }, [setSearchTerm]);
  var clearSearch = useCallback(function () {
    setSearchTerm('');
  }, [setSearchTerm]);
  return {
    clearSearch: clearSearch,
    filteredItems: filteredItems,
    setSearch: setSearch,
    searchTerm: searchTerm
  };
}
//# sourceMappingURL=useSearch.js.map