import React from 'react';
import type { MenuRef } from '../MenuImperative/MenuImperative.types';
import type { Id, TieredSelectApi, TieredSelectProps } from './TieredSelect.types';
export declare const useHighlightItemEffects: ({ currentTier, searchValue, menuRef, loading, loadingMore, }: {
    currentTier: Id;
    searchValue: string;
    menuRef: React.RefObject<MenuRef>;
    loading: TieredSelectProps['loading'];
    loadingMore: TieredSelectProps['loadingMore'];
}) => void;
export declare const TieredSelectContext: React.Context<TieredSelectApi>;
/**

 We use tiered selects to allow users to choose a single parent or child option
 that is nested within a tiered list. For example, choosing a location from
 within a list of tiered locations. We typically see these selects on forms.

 Other select components are group select, multi select, and select.
 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-tieredselect--demo)

 @see [Design Guidelines](https://design.procore.com/tiered-select)

 */
export declare const TieredSelect: React.ForwardRefExoticComponent<TieredSelectProps & React.RefAttributes<HTMLDivElement>>;
