import React from 'react';
import type { ButtonAttributes, DivAttributes, Props, SpanAttributes } from '../_utils/types';
import type { ToastProps } from './Toast.types';
export declare const Toast_: React.ForwardRefExoticComponent<DivAttributes & ToastProps & React.RefAttributes<HTMLDivElement>>;
/**

 We use toasts to temporarily display information to a user. For example,
 as a confirmation that an action was successfully or unsuccessfully completed.

 Toasts do not present the user with an action. If an action needs to be
 performed because of the particular message, use a banner. However, for
 accessible 'enough time' patterns, Toasts can be extended and can have
 an action to dismiss the Toast.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-toast--demo)

 @see [Design Guidelines](https://design.procore.com/toast)

 */
export declare const Toast: React.ForwardRefExoticComponent<DivAttributes & ToastProps & React.RefAttributes<HTMLDivElement>> & {
    Dismiss: React.ForwardRefExoticComponent<ButtonAttributes & Props & React.RefAttributes<HTMLButtonElement>>;
    Text: React.ForwardRefExoticComponent<SpanAttributes & Props & React.RefAttributes<HTMLSpanElement>>;
};
