var _excluded = ["children", "selected", "icon", "size"];
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { StyledToggleButton } from './ToggleButton.styles';
/**

 A toggle button can be used when an element needs to remain active or open
 for extended periods of time. The affects of a toggle button should visibly
 change content on the page.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-togglebutton--demo)

 @see [Design Guidelines](https://design.procore.com/toggle-button)

 @a11y  @a11y Important: it is critical the label on a toggle does not change when its `selected` prop changes. Alternatively, if the design were to call for the button label to change from "Mute" to "Unmute," the `aria-pressed` prop should be set to `undefined`.

 @see https://www.w3.org/WAI/ARIA/apg/patterns/button/

 */
export var ToggleButton = /*#__PURE__*/React.forwardRef(function ToggleButton(_ref, ref) {
  var children = _ref.children,
    _ref$selected = _ref.selected,
    selected = _ref$selected === void 0 ? false : _ref$selected,
    icon = _ref.icon,
    size = _ref.size,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledToggleButton, _extends({
    "aria-pressed": selected
  }, props, {
    $selected: selected,
    icon: icon,
    size: size,
    variant: "tertiary",
    ref: ref
  }), children || null);
});
ToggleButton.displayName = 'ToggleButton';
//# sourceMappingURL=ToggleButton.js.map