/// <reference types="react" />
import type { ButtonSizes } from '../Button/Button.types';
import type { ButtonAttributes } from '../_utils/types';
export interface ToggleButtonProps extends ButtonAttributes {
    /**
     * Set the current value of the toggle button
     * @default false
     * @since 10.19.0
     */
    selected?: boolean;
    /**
     * The icon to display on the left side of the label. This should be an
     * icon from `@procore/core-icons`.
     * @since 10.19.0
     */
    icon?: React.ReactNode;
    /**
     * Shows the toggle button spinner
     * @since 12.13.0
     */
    loading?: boolean;
    /**
     * The toggle button size
     * @since 10.19.0
     */
    size?: ButtonSizes;
}
