import React from 'react';
import type { DivAttributes, Props, SpanAttributes, SVGAttributes } from '../_utils/types';
import type { TokenProps } from './Token.types';
/**

 We use tokens in our multi select dropdowns and file attachers to indicate what
 has been selected or attached. Tokens in these components are removable.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-token--demo)

 @see [Design Guidelines](https://design.procore.com/tokens)

 */
export declare const Token: React.ForwardRefExoticComponent<DivAttributes & TokenProps & React.RefAttributes<HTMLDivElement>> & {
    Label: React.ForwardRefExoticComponent<SpanAttributes & Props & React.RefAttributes<HTMLSpanElement>>;
    Remove: React.ForwardRefExoticComponent<SVGAttributes & Props & React.RefAttributes<SVGSVGElement>>;
};
