var _excluded = ["children", "disabled", "focused", "error", "variant"],
  _excluded2 = ["children"];
function _objectDestructuringEmpty(t) { if (null == t) throw new TypeError("Cannot destructure " + t); }
function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
function _objectWithoutProperties(e, t) { if (null == e) return {}; var o, r, i = _objectWithoutPropertiesLoose(e, t); if (Object.getOwnPropertySymbols) { var n = Object.getOwnPropertySymbols(e); for (r = 0; r < n.length; r++) o = n[r], -1 === t.indexOf(o) && {}.propertyIsEnumerable.call(e, o) && (i[o] = e[o]); } return i; }
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import React from 'react';
import { useI18nContext } from '../_hooks/I18n';
import { addSubcomponents } from '../_utils/addSubcomponents';
import { StyledLabel, StyledRemove, StyledToken } from './Token.styles';
var Parent = /*#__PURE__*/React.forwardRef(function Token(_ref, ref) {
  var children = _ref.children,
    _ref$disabled = _ref.disabled,
    disabled = _ref$disabled === void 0 ? false : _ref$disabled,
    _ref$focused = _ref.focused,
    focused = _ref$focused === void 0 ? false : _ref$focused,
    _ref$error = _ref.error,
    error = _ref$error === void 0 ? false : _ref$error,
    variant = _ref.variant,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/React.createElement(StyledToken, _extends({}, props, {
    ref: ref,
    $disabled: disabled || variant === 'disabled',
    $focused: focused || variant === 'focused',
    $error: error
  }), children);
});
var Remove = /*#__PURE__*/React.forwardRef(function TokenRemove(_ref2, ref) {
  var props = _extends({}, (_objectDestructuringEmpty(_ref2), _ref2));
  var i18n = useI18nContext();
  return /*#__PURE__*/React.createElement(StyledRemove, _extends({
    ref: ref,
    "aria-hidden": "false",
    "aria-label": i18n.t('core.token.remove')
  }, props));
});
var Label = /*#__PURE__*/React.forwardRef(function Label(_ref3, ref) {
  var children = _ref3.children,
    props = _objectWithoutProperties(_ref3, _excluded2);
  return /*#__PURE__*/React.createElement(StyledLabel, _extends({
    ref: ref
  }, props), children);
});
Parent.displayName = 'Token';
Remove.displayName = 'Token.Remove';
Label.displayName = 'Token.Label';

/**

 We use tokens in our multi select dropdowns and file attachers to indicate what
 has been selected or attached. Tokens in these components are removable.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-token--demo)

 @see [Design Guidelines](https://design.procore.com/tokens)

 */
export var Token = addSubcomponents({
  Label: Label,
  Remove: Remove
}, Parent);
//# sourceMappingURL=Token.js.map