export interface TokenProps {
    /**
     * Disables the token
     * @since 10.19.0
     */
    disabled?: boolean;
    /**
     * @since 10.19.0
     */
    focused?: boolean;
    /**
     * @since 10.19.0
     */
    error?: boolean;
    /**
     * @deprecated
     *
     * All variants have been deprecated and will be removed in a future version.
     * Please use `Token.Remove` component or `disabled` boolean prop instead.
     *
     * **Before**
     *
     * `<Token variant='icon'>
     *    <Token.Icon icon="x" />
     * </Token>`
     *
     * **After**
     *
     * `<Token>
     *    <Token.Remove />
     * </Token>`
     *
     * @deprecatedSince 10.27.0
     */
    variant?: 'disabled' | 'focused' | 'icon' | 'standard';
}
