/// <reference types="react" />
import type { Polymorphic } from '../_utils/polymorphic';
import type { AriaLabelled } from '../_utils/types';
export declare type ActionIconPolyType = 'link' | 'button';
export interface ActionIconPolyTagMap extends Record<ActionIconPolyType, React.ElementType> {
    link: 'a';
    button: 'button';
}
export declare type ActionIconRef<Role extends ActionIconPolyType> = Polymorphic.Ref<ActionIconPolyTagMap, Role>;
export declare type ActionIconProps<Role extends ActionIconPolyType> = Role extends 'link' ? Polymorphic.ComponentPropsWithRef<ActionIconPolyTagMap, 'link', 'href' | 'aria-label'> : Role extends 'button' ? AriaLabelled<Polymorphic.ComponentPropsWithRef<ActionIconPolyTagMap, 'button', 'onClick'>> : unknown;
