import React from 'react';
import type { DivAttributes, Props, SVGAttributes } from '../_utils/types';
import type { ToolHeaderBadgeProps, ToolHeaderIconProps, ToolHeaderSettingsActionPolyType, ToolHeaderSettingsActionProps, ToolHeaderSettingsActionRef } from './ToolHeader.types';
export declare const Icon: React.ForwardRefExoticComponent<SVGAttributes & ToolHeaderIconProps & React.RefAttributes<HTMLDivElement>>;
declare function SettingsActionInner<Role extends ToolHeaderSettingsActionPolyType>(props: ToolHeaderSettingsActionProps<Role>, ref: ToolHeaderSettingsActionRef<Role>): React.JSX.Element;
export declare const Title: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<import("../Semantic/Semantic.types").HeadingProps & React.RefAttributes<HTMLHeadingElement>>, any, {}, never>;
export declare const Tabs: React.ForwardRefExoticComponent<DivAttributes & Props & React.RefAttributes<HTMLDivElement>>;
export declare const Actions: import("styled-components").StyledComponent<"div", any, {}, never>;
/**
 * @deprecated
 *
 * This `Badge` pattern is no longer supported and it is now recommended to use a `Pill` instead.
 *
 * @deprecatedSince 10.20.0
 *
 * @see https://core.procore.com/latest/web/components/pill/react/
 */
export declare const Badge: React.ForwardRefExoticComponent<DivAttributes & ToolHeaderBadgeProps & React.RefAttributes<HTMLDivElement>>;
/**
 * @deprecated This `ToolHeader` component is no longer supported and it is now recommended
 * to use the layout `ToolLandingPage`, `ToolLandingPage.Title` (for the settings button),
 * `ToolLandingPage.Tabs`, or based on content a `DetailPage`.
 *
 * @deprecatedSince 12.9.0
 *
 * @see https://stories.core.procore.com/?path=/story/core-react_demos-toollandingpage--demo
 */
export declare const ToolHeader: React.ForwardRefExoticComponent<Omit<any, "ref"> & React.RefAttributes<HTMLDivElement>> & {
    Icon: React.ForwardRefExoticComponent<SVGAttributes & ToolHeaderIconProps & React.RefAttributes<HTMLDivElement>>;
    Title: import("styled-components").StyledComponent<React.ForwardRefExoticComponent<import("../Semantic/Semantic.types").HeadingProps & React.RefAttributes<HTMLHeadingElement>>, any, {}, never>;
    Tabs: React.ForwardRefExoticComponent<DivAttributes & Props & React.RefAttributes<HTMLDivElement>>;
    Actions: import("styled-components").StyledComponent<"div", any, {}, never>;
    Badge: React.ForwardRefExoticComponent<DivAttributes & ToolHeaderBadgeProps & React.RefAttributes<HTMLDivElement>>;
    SettingsAction: <Role extends ToolHeaderSettingsActionPolyType>(props: ToolHeaderSettingsActionProps<Role>) => ReturnType<typeof SettingsActionInner>;
};
export {};
