/// <reference types="react" />
import type { Polymorphic } from '../_utils/polymorphic';
import type { Props } from '../_utils/types';
export declare type ToolHeaderBadgeVariant = 'beta' | 'new' | 'trial';
export interface ToolHeaderBadgeProps extends Props {
    /**
     * Controls the background/border/text colors of the Badge's pill
     * @since 10.19.0
     */
    variant: ToolHeaderBadgeVariant;
}
export interface ToolHeaderIconProps extends Props {
    /**
     * @since 10.19.0
     */
    icon?: React.ReactNode;
}
export declare type ToolHeaderSettingsActionPolyType = 'link' | 'button';
export interface ToolHeaderSettingsActionPolyTagMap extends Record<ToolHeaderSettingsActionPolyType, React.ElementType> {
    link: 'a';
    button: 'button';
}
export declare type ToolHeaderSettingsActionRef<Role extends ToolHeaderSettingsActionPolyType> = Polymorphic.Ref<ToolHeaderSettingsActionPolyTagMap, Role>;
export declare type ToolHeaderSettingsActionProps<Role extends ToolHeaderSettingsActionPolyType> = Role extends 'link' ? Polymorphic.ComponentPropsWithRef<ToolHeaderSettingsActionPolyTagMap, 'link', 'href', {
    'aria-label'?: string;
}> : Role extends 'button' ? Polymorphic.ComponentPropsWithRef<ToolHeaderSettingsActionPolyTagMap, 'button', 'onClick', {
    'aria-label'?: string;
}> : unknown;
