import React from 'react';
import type { Props } from '../_utils/types';
import type { ToolLandingPageProps, ToolLandingPageTitleProps } from './ToolLandingPage.types';
export declare const ToolLandingPage_: React.ForwardRefExoticComponent<ToolLandingPageProps & React.RefAttributes<HTMLDivElement>>;
export declare const Title: React.ForwardRefExoticComponent<ToolLandingPageTitleProps & React.RefAttributes<HTMLDivElement>>;
export declare const Body: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
/**
 * A list page is basically a copy of SettingsPage/DetailPage. However, it has some differences.
 * ToolLandingPage does not have Breadcrumbs, nested sections (although, we may need them in the future), and Footer.
 *
 * @since 12.9.0
 *
 * @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-toollandingpage--demo)
 *
 * @see [Design Guidelines](https://design.procore.com/tool-landing-layout)
 */
export declare const ToolLandingPage: React.ForwardRefExoticComponent<ToolLandingPageProps & React.RefAttributes<HTMLDivElement>> & {
    Main: React.ForwardRefExoticComponent<import("../PageLayout/PageLayout.types").PageMainProps & React.RefAttributes<HTMLDivElement>>;
    Header: React.ForwardRefExoticComponent<import("../PageLayout").PageHeaderProps & React.RefAttributes<HTMLDivElement>>;
    Banner: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Title: React.ForwardRefExoticComponent<ToolLandingPageTitleProps & React.RefAttributes<HTMLDivElement>>;
    Tabs: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Body: React.ForwardRefExoticComponent<Props & React.RefAttributes<HTMLDivElement>>;
    Aside: React.ForwardRefExoticComponent<import("../PageLayout").PageAsideProps & React.RefAttributes<HTMLDivElement>>;
};
