import React from 'react';
import type { OverlayTriggerProps } from '../OverlayTrigger';
import type { TooltipContentProps, TooltipProps } from './Tooltip.types';
/**

 We use tooltips to display additional descriptive information about an element
 or item to the user. For example, we could use them to explain a specific term
 or phrase, to denote the specific format required (e.g. mm/dd/yyy), or to
 clarify certain information (e.g. why a button is disabled).

 They can be displayed either by hovering over an element in the product or by
 hovering over an icon next to an element.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-tooltip--demo)

 @see [Design Guidelines](https://design.procore.com/tooltip)

 */
export declare const Tooltip: React.ForwardRefExoticComponent<OverlayTriggerProps & TooltipProps & React.RefAttributes<HTMLElement>> & {
    Content: React.ForwardRefExoticComponent<TooltipContentProps & React.RefAttributes<HTMLSpanElement>>;
};
