import type { OverlayTriggerProps } from '../OverlayTrigger/OverlayTrigger.types';
import type { Placement } from '../_utils/placement';
import type { Props } from '../_utils/types';
export interface TooltipContentProps extends Props {
    /**
     * @since 10.19.0
     */
    placement?: Placement;
}
export interface TooltipProps extends Props {
    /**
     * @since 10.19.0
     */
    hideDelay?: number;
    /**
     * Whether to show the overlay on initial render
     * @since 10.19.0
     */
    initialIsVisible?: boolean;
    /**
     * The tip we want to display
     * @since 10.19.0
     */
    overlay?: any;
    /**
     * Determines the position of the arrow
     * @since 10.19.0
     */
    placement?: Placement;
    /**
     * @since 10.19.0
     */
    showDelay?: number;
    /**
     * The event to trigger the overlay
     * @since 10.19.0
     */
    trigger?: OverlayTriggerProps['trigger'];
}
