import React from 'react';
import type { CustomDataType, Node, TreeNodeId, TreeProps, TreeRef } from './Tree.types';
export declare const UNSAFE_treeRootNodeId = "ROOT_ID";
export declare function isRootNode(parentId: TreeNodeId): boolean;
/**

 The tree allows users to navigate between folder / file directories,
 and optionally select those files.

 @since 10.19.0

 @see [Storybook](https://stories.core.procore.com/?path=/story/core-react_demos-tree--demo)

 @see [Design Guidelines](https://design.procore.com/tree)

 */
export declare const Tree: React.ForwardRefExoticComponent<TreeProps<Node, CustomDataType<Node>> & React.RefAttributes<TreeRef<Node>>>;
