import type React from 'react';
import type { PortalProps } from '../Portal/Portal.types';
export interface ClickOutsideConfig extends Pick<PortalProps, 'container'> {
    /**
     * @since 10.19.0
     */
    onClickOutside: (event: MouseEvent) => void;
    /**
     * @since 10.19.0
     */
    refs: Array<React.RefObject<HTMLElement>>;
}
export interface ClickOutsideProps extends ClickOutsideConfig {
    /**
     * @since 10.19.0
     */
    children: React.ReactElement;
}
/**
 * @deprecatedSince 9
 * @deprecated Never officially documented/supported
 */
export declare function isEventSource(ref: React.RefObject<any>, event: Event): any;
/**
 * @deprecatedSince 9
 * @deprecated Never officially documented/supported
 */
export declare function useClickOutside({ refs, onClickOutside, container, }: ClickOutsideConfig): void;
