import type { FocusScopeProps } from '@react-aria/focus';
import React from 'react';
/**
 * STOP - READ BEFORE USING
 *
 * The following wrapper was added to help TinyMCE modals.
 * When used with React Aria contained Focus Scope,
 * focus does not move into the TinyMCE modal.
 * This patch gets critical functionality back at
 * the cost of possibly failing accessbility.
 * This hack keeps bugfixes for TinyMCE internal.
 * If a TextEditor isn't really a valid child,
 * use the plain FocusScope from React Aria.
 */
declare type OverrideProps = Omit<FocusScopeProps, 'children'>;
export declare function useOverridableFocusScope(): {
    setProps: (arg: OverrideProps) => void;
};
export declare function OverridableFocusScope(props: FocusScopeProps): React.JSX.Element;
export {};
