import type { I18njs, I18njsConfig } from '@procore/core-i18n-js';
import React from 'react';
declare type I18nConfig = Omit<I18njsConfig, 'I18n'>;
/**
 * @deprecated this type will no longer be supported from core-i18n-js,
 * to have a type safe Locale use TmsSupportedLocale or AllLocales from [Globalization toolkit](https://github.com/procore/globalization-toolkit)
 * @deprecatedSince 12.10.0
 */
export declare type Locale = 'de-DE' | 'en-AE' | 'en-AU' | 'en-CA' | 'en-GB' | 'en-SG' | 'en' | 'es-ES' | 'es' | 'fr-CA' | 'fr-FR' | 'is-IS' | 'ja-JP' | 'pt-BR' | 'th-TH' | 'zh-SG' | 'pseudo' | 'pl-PL';
export declare const coreTranslations: {
    readonly 'de-DE': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly en: {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'en-AU': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'en-CA': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'en-GB': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly es: {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'es-ES': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'fr-CA': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'fr-FR': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'is-IS': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'ja-JP': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly pseudo: {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'pt-BR': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'th-TH': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'zh-SG': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
    readonly 'pl-PL': {
        core: {
            banner: {
                dismissAlert: string;
            };
            breadcrumbs: {
                label: string;
            };
            calendar: {
                navigationLabel: string;
            };
            connected: {
                fileSelect: {
                    documents: string;
                    drawings: string;
                    forms: string;
                    photos: string;
                    selectAlbum: string;
                    selectAnAlbum: string;
                    selectArea: string;
                    selectAnArea: string;
                    selectDiscipline: string;
                    selectADiscipline: string;
                    selectSet: string;
                    selectASet: string;
                    selectTemplate: string;
                    selectATemplate: string;
                };
                emails: {
                    emailSendErrorTitle: string;
                    emailBodyRequiredError: string;
                    emailContentValidationError: string;
                    emailContentDisclaimer: string;
                    recipientSelectPlaceholder: string;
                    emailRecipientRequiredError: string;
                    emailSubjectRequiredError: string;
                    goToAllEmails: string;
                    sendEmail: string;
                    replyAll: string;
                    downloadAll: string;
                    showAll: string;
                    showLess: string;
                    composeEmailPageTitle: string;
                    emailSentMessage: string;
                    from: string;
                    to: string;
                    cc: string;
                    bcc: string;
                    downloadPdfLong: string;
                    downloadPdfShort: string;
                    privateEmailDisclaimer: string;
                    privateLabel: string;
                    settingsLink: string;
                    composeNewEmail: string;
                    startNewCommunication: string;
                    emptyStateTitle: string;
                    emptyStateDescription: string;
                    reply: string;
                    cancel: string;
                    subject: string;
                    subjectPlaceholder: string;
                };
                distributionSelect: {
                    noCompany: string;
                    peopleCount: string;
                    distributionGroups: string;
                    people: string;
                };
                relatedItems: {
                    cancel: string;
                    close: string;
                    date: string;
                    itemType: string;
                    itemTypeGroupLabel: {
                        dailyLog: string;
                        prostoreFile: string;
                    };
                    itemName: string;
                    loading: string;
                    notes: string;
                    notesPlaceholder: string;
                    newItem: string;
                    noRelatedItems: {
                        title: string;
                        description: string;
                    };
                    noItems: {
                        title: string;
                        description: string;
                    };
                    noResultsSearchQuery: {
                        title: string;
                        description: string;
                    };
                    noResultsServerError: {
                        title: string;
                        description: string;
                        action: string;
                    };
                    panelTitle: string;
                    search: string;
                    searchItemType: string;
                    submit: string;
                    toast: {
                        itemAdded: string;
                        itemAdditionFailed: string;
                        itemRemoved: string;
                        requestError: string;
                    };
                };
            };
            dateTimeFormat: {
                dateAtTime: string;
                timeOnDate: string;
            };
            table: {
                sortableColumn: string;
            };
            dataTable: {
                emptyState: {
                    noFilteredResults: {
                        description: string;
                        title: string;
                    };
                };
                exporting: string;
                filters: {
                    filters: string;
                    moreFilters: string;
                    clearAllFilters: string;
                };
                grandTotals: string;
                search: string;
                subtotals: string;
                tableSettings: {
                    configureColumns: string;
                    resetToDefault: string;
                    rowHeight: string;
                    small: string;
                    medium: string;
                    large: string;
                    tableSettings: string;
                };
            };
            dateInput: {
                clear: string;
                ariaLabel: string;
                segment: {
                    ariaLabel: {
                        withValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                        withoutValue: {
                            month: string;
                            day: string;
                            year: string;
                        };
                    };
                    ariaValueText: {
                        empty: string;
                    };
                };
                clearButton: {
                    ariaLabel: string;
                };
            };
            dropdown: {
                search: string;
                moreOptions: string;
                loading: string;
            };
            dropzone: {
                uploadFiles: {
                    one: string;
                    other: string;
                };
                dragAndDrop: string;
                incorrectFileTypeMessage: {
                    one: string;
                    other: string;
                };
                incorrectFileNumber: string;
                invalidAmountAttachments: {
                    one: string;
                    other: string;
                };
                hideDetails: string;
                showDetails: string;
                errorTitle: string;
                oneFileAtATimeError: string;
                multipleErrorsMessage: string;
                maxFileSizeErrorGroup: string;
                minFileSizeErrorGroup: string;
                zeroFileSizeErrorGroup: string;
                maxFileNumberErrorGroup: string;
                wrongFileTypeErrorGroup: string;
                standaloneMaxFileNumberError: string;
                standaloneUnsupportedFileTypeError: string;
                standaloneMinFileSizeError: string;
                standaloneMaxFileSizeError: string;
                standaloneZeroFileSizeError: string;
                uploadTotalProgress: {
                    withFailed: string;
                    withoutFailed: string;
                };
            };
            modal: {
                a11y: {
                    close: string;
                };
                cancel: string;
            };
            multiSelect: {
                clearAll: string;
                selectValues: string;
                noResults: string;
            };
            tearsheet: {
                a11y: {
                    close: string;
                };
            };
            fileAttacher: {
                attachFiles: {
                    one: string;
                    other: string;
                };
            };
            fileToken: {
                uploading: string;
            };
            tree: {
                selectionLimit: {
                    one: string;
                    other: string;
                };
                unsupportedFileType: {
                    specific: string;
                    unspecific: string;
                };
            };
            fileExplorer: {
                filesSelectedWithLimit: string;
                ungroupedThumbnailGridGroup: string;
                filesSelected: {
                    one: string;
                    other: string;
                };
                cancelAction: string;
                attachAction: string;
                maxNumberOfFilesSelected: string;
                modalTitle: string;
                filesPendingUpload: string;
                noSelectedItems: string;
                emptySearchResults: string;
                noItems: string;
                searchPlaceholder: string;
                uploadFailed: string;
                supportedFileTypes: string;
            };
            form: {
                closeWithConfirm: {
                    confirmMessage: string;
                };
                checkbox: {
                    no: string;
                    yes: string;
                    checked: string;
                    unchecked: string;
                };
                errorBanner: {
                    couldNotCreateItem: string;
                    couldNotUpdateItem: string;
                    fixErrorsToCreate: string;
                    fixErrorsToUpdate: string;
                };
                field: {
                    tooltipHelp: string;
                };
            };
            menu: {
                search: string;
            };
            pagination: {
                interval: string;
                notation: string;
                page: string;
                nextPage: string;
                prevPage: string;
            };
            search: {
                clear: string;
                goSearch: string;
            };
            select: {
                clear: string;
                search: string;
            };
            splitViewCard: {
                a11y: {
                    close: string;
                };
            };
            tabs: {
                more: string;
            };
            thumbnail: {
                checked: string;
            };
            thumbnailList: {
                removeUpload: string;
                uploading: string;
            };
            toast: {
                a11y: {
                    dismiss: string;
                };
            };
            fileList: {
                downloadAll: string;
                download: string;
                noPreview: string;
            };
            tieredSelect: {
                emptyMessage: string;
                goToTier: string;
                placeholder: string;
                quickCreateActionLabel: string;
                quickCreateCancelLabel: string;
                quickCreateCreateLabel: string;
                quickCreatePlaceholder: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            tieredDropdown: {
                emptyMessage: string;
                searchEmptyMessage: string;
                searchPlaceholder: string;
                spinnerLabel: string;
            };
            token: {
                remove: string;
            };
            toolHeader: {
                settingsAction: string;
            };
            fileSelect: {
                localFilesSource: string;
                uploadFailed: string;
                maxNumberOfFilesSelected: string;
            };
            required: {
                requiredFields: string;
            };
            avatarStack: {
                viewAll: string;
                close: string;
            };
            panel: {
                close: string;
                goBack: string;
            };
            menuImperative: {
                options: {
                    ariaLabel: string;
                };
            };
        };
    };
};
export declare function useI18n({ locale: _locale, translations: _translations, }: I18njsConfig): I18njs;
export declare const I18nContext: React.Context<I18njs>;
export declare function I18nProvider({ children, ...props }: I18nConfig & {
    children: React.ReactNode;
}): React.JSX.Element;
declare type DeepStringRecord = {
    [key: string]: string | DeepStringRecord;
};
declare type PluralizationForm = {
    zero?: string;
    one: string;
    other: string;
};
declare type DotPrefix<T extends string> = T extends '' ? '' : `.${T}`;
declare type DotNestedKeys<T> = (T extends string ? '' : T extends DeepStringRecord ? {
    [K in keyof T]: K extends string ? T[K] extends PluralizationForm ? `${K}` : T[K] extends DeepStringRecord ? `${K}${DotPrefix<DotNestedKeys<T[K]>>}` : `${K}` : never;
}[keyof T] : '') extends infer D ? Extract<D, string> : never;
declare type StringLiteralPathValue<T, P extends string> = P extends `${infer K}.${infer Rest}` ? K extends keyof T ? T[K] extends PluralizationForm ? T[K] : T[K] extends DeepStringRecord ? StringLiteralPathValue<T[K], Rest> : never : never : P extends keyof T ? T[P] extends PluralizationForm ? T[P] : T[P] extends string ? T[P] : never : never;
declare type HasInterpolation<T extends string> = T extends `${string}%{${string}}${string}` ? true : false;
declare type ExtractInterpolationVars<T extends string> = T extends `${infer _Before}%{${infer Param}}${infer After}` ? Param | ExtractInterpolationVars<After> : never;
declare type ExplicitTranslateOptions = {
    [K in keyof I18n.TranslateOptions as string extends K ? never : K]: I18n.TranslateOptions[K];
};
declare type InterpolationParams<T extends string> = HasInterpolation<T> extends true ? {
    [K in ExtractInterpolationVars<T>]: string;
} & {
    [K in keyof ExplicitTranslateOptions]?: ExplicitTranslateOptions[K];
} : never;
declare type PluralizationParams<T extends PluralizationForm> = {
    count: number;
} & ((T['zero'] extends string ? {
    count: 0;
} & {
    [K in ExtractInterpolationVars<T['zero']>]: string;
} : {}) | (T['one'] extends string ? {
    count: 1;
} & {
    [K in ExtractInterpolationVars<T['one']>]: string;
} : {}) | (T['other'] extends string ? {
    count: number;
} & {
    [K in ExtractInterpolationVars<T['other']>]: string;
} : {})) & {
    [K in keyof ExplicitTranslateOptions]?: ExplicitTranslateOptions[K];
};
declare type InterpolationOrPluralizationParams<T> = T extends PluralizationForm ? [PluralizationParams<T>] : T extends string ? InterpolationParams<T> extends never ? [ExplicitTranslateOptions?] : [InterpolationParams<T>] : [ExplicitTranslateOptions?];
declare type TypedTranslate<Translations> = <P extends DotNestedKeys<Translations>>(path: P, ...args: InterpolationOrPluralizationParams<StringLiteralPathValue<Translations, P>>) => StringLiteralPathValue<Translations, P>;
declare type I18njsWithTypedTranslate<Translations> = Omit<I18njs, 't' | 'translate'> & {
    t: TypedTranslate<Translations>;
    translate: TypedTranslate<Translations>;
};
export declare function useI18nContext<Translations extends DeepStringRecord | undefined = undefined>(): Translations extends undefined ? I18njs : I18njsWithTypedTranslate<NonNullable<Translations>>;
export declare function useI18nContext(): I18njs;
export {};
