/// <reference types="react" />
export interface OverflowState {
    /**
     * @since 10.19.0
     */
    ref: (el: HTMLElement | null) => void;
    /**
     * @description Is overflowing along X or Y axis (horizontally or vertically)
     * @since 10.19.0
     */
    isOverflowing: boolean;
    /**
     * @description Is overflowing along X axis (horizontally)
     * @since 10.19.0
     */
    isOverflowingX: boolean;
    /**
     * @description Is overflowing along Y axis (vertically)
     * @since 10.19.0
     */
    isOverflowingY: boolean;
}
export interface OverflowObserverProps {
    children(state: OverflowState): JSX.Element;
}
