function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
/* eslint-disable no-magic-numbers */
import React from 'react';
/**
 * Minimum size for that breakpoint to be active
 */
export var breakpointsMinSize = {
  mobile: 0,
  tabletPortrait: 768,
  tabletLandscape: 1024,
  desktop: 1440
};

/**
 * Maximum size for that breakpoint to be active
 */
export var breakpointsMaxSize = {
  mobile: breakpointsMinSize.tabletPortrait - 1,
  tabletPortrait: breakpointsMinSize.tabletLandscape - 1,
  tabletLandscape: breakpointsMinSize.desktop - 1,
  // setting to Infinity messes with matchMedia queries
  // getMediaQueryString would have to check and adjust the string
  desktop: breakpointsMinSize.desktop + 10000
};
export var defaultMediaConfig = {
  mobile: "(width <= ".concat(breakpointsMaxSize.mobile, "px)"),
  tabletPortrait: "(".concat(breakpointsMinSize.tabletPortrait, "px <= width <= ").concat(breakpointsMaxSize.tabletPortrait, "px)"),
  tabletLandscape: "(".concat(breakpointsMinSize.tabletLandscape, "px <= width <= ").concat(breakpointsMaxSize.tabletLandscape, "px)"),
  desktop: "(min-width: ".concat(breakpointsMinSize.desktop, "px)")
};

/**
 * Point in time check if matching a specific breakpoint
 */
export function getCurrentMedia() {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultMediaConfig;
  var isMobile = window.matchMedia(config.mobile).matches;
  var isTabletPortrait = window.matchMedia(config.tabletPortrait).matches;
  var isTabletLandscape = window.matchMedia(config.tabletLandscape).matches;
  var isDesktop = window.matchMedia(config.desktop).matches;
  return {
    isMobile: isMobile,
    isTabletPortrait: isTabletPortrait,
    isTabletLandscape: isTabletLandscape,
    isDesktop: isDesktop
  };
}

/**
 * Reactive check if matching a specific breakpoint
 */
export function useCurrentMedia() {
  var _React$useState = React.useState(getCurrentMedia()),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    currentMedia = _React$useState2[0],
    setCurrentMedia = _React$useState2[1];
  React.useEffect(function () {
    function handleResize() {
      setCurrentMedia(getCurrentMedia());
    }
    window.addEventListener('resize', handleResize);
    return function () {
      return window.removeEventListener('resize', handleResize);
    };
  }, []);
  return currentMedia;
}
//# sourceMappingURL=useCurrentMedia.js.map