function _slicedToArray(r, e) { return _arrayWithHoles(r) || _iterableToArrayLimit(r, e) || _unsupportedIterableToArray(r, e) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(r, a) { if (r) { if ("string" == typeof r) return _arrayLikeToArray(r, a); var t = {}.toString.call(r).slice(8, -1); return "Object" === t && r.constructor && (t = r.constructor.name), "Map" === t || "Set" === t ? Array.from(r) : "Arguments" === t || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(t) ? _arrayLikeToArray(r, a) : void 0; } }
function _arrayLikeToArray(r, a) { (null == a || a > r.length) && (a = r.length); for (var e = 0, n = Array(a); e < a; e++) n[e] = r[e]; return n; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(r) { if (Array.isArray(r)) return r; }
import React from 'react';
export function useSet() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$initialValue = _ref.initialValue,
    initialValue = _ref$initialValue === void 0 ? new Set() : _ref$initialValue,
    onChange = _ref.onChange,
    onAdd = _ref.onAdd,
    onRemove = _ref.onRemove;
  var _React$useState = React.useState(initialValue),
    _React$useState2 = _slicedToArray(_React$useState, 2),
    collection = _React$useState2[0],
    setCollection = _React$useState2[1];
  var removeFromSet = React.useCallback(function (collection, item) {
    collection["delete"](item);
    onRemove === null || onRemove === void 0 ? void 0 : onRemove(item);
    return new Set(collection);
  }, [onRemove]);
  var addToSet = React.useCallback(function (collection, item) {
    collection.add(item);
    onAdd === null || onAdd === void 0 ? void 0 : onAdd(item);
    return new Set(collection);
  }, [onAdd]);
  var updateCollection = React.useCallback(function (updater) {
    setCollection(function (prevCollection) {
      var newCollection = updater(prevCollection);
      onChange === null || onChange === void 0 ? void 0 : onChange(newCollection);
      return newCollection;
    });
  }, [onChange]);
  var has = React.useCallback(function (item) {
    return collection.has(item);
  }, [collection]);
  var add = React.useCallback(function (item) {
    return updateCollection(function (prevCollection) {
      return addToSet(prevCollection, item);
    });
  }, [addToSet, updateCollection]);
  var remove = React.useCallback(function (item) {
    return updateCollection(function (prevCollection) {
      return removeFromSet(prevCollection, item);
    });
  }, [removeFromSet, updateCollection]);
  var set = React.useCallback(function (newCollection) {
    return updateCollection(function () {
      return newCollection;
    });
  }, [updateCollection]);
  var toggle = React.useCallback(function (item) {
    return updateCollection(function (prevCollection) {
      return prevCollection.has(item) ? removeFromSet(prevCollection, item) : addToSet(prevCollection, item);
    });
  }, [addToSet, removeFromSet, updateCollection]);
  var removeAll = React.useCallback(function () {
    return updateCollection(function () {
      return new Set();
    });
  }, [updateCollection]);
  return {
    collection: collection,
    setCollection: set,
    has: has,
    add: add,
    remove: remove,
    removeAll: removeAll,
    toggle: toggle
  };
}
//# sourceMappingURL=useSet.js.map