import type { Editor } from '@tinymce/tinymce-react';
import type { Locale } from '../_hooks/I18n';
export declare const scriptId = "tiny-mce-core-source";
export declare const tinyMCESource = "https://s3.amazonaws.com/procore-core/tinymce";
export declare const tinyMCEVersion = "5.8.1";
export declare const defaultPlugins: string[];
export declare const plugins: string[];
/**
 *  Historically, `nonbreaking_force_tab` has been set to `true`
 *  and this takes the `Tab` keypress as input to add to the content.
 *  e.g indent the start of the text block like a paragraph.
 *  This is different from the TinyMCE tool and command 'Indent', which
 *  indents the entire block. e.g. indent this entire text block and the
 *  wrapped lines.
 *  This is the HTML it outputs when `nonbreaking_force_tab: true`
 */
export declare const tinyMCETabMarkup = "<span class=\"mce-nbsp-wrap\" contenteditable=\"false\">&nbsp;&nbsp;&nbsp;</span>";
export declare const tinyMCEConfig: any & Editor;
export declare function getValidLookupLocale(locale: Locale): string;
export declare function generateLanguageUrl(locale: Locale): string;
export declare function generateExternalPlugins(plugins: Array<string>, basePlugins?: string[]): {};
