function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(e, r, t) { return (r = _toPropertyKey(r)) in e ? Object.defineProperty(e, r, { value: t, enumerable: !0, configurable: !0, writable: !0 }) : e[r] = t, e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import { DateTimeFormatter } from '@procore/globalization-toolkit';
import * as R from 'ramda';
import { getFormatterLocale } from './i18n';
var dateTimePresets = {
  time: {
    hour: 'numeric',
    minute: 'numeric',
    timeZoneName: 'short'
  },
  'abbr-weekday-abbr-date': {
    weekday: 'short',
    year: 'numeric',
    month: 'short',
    day: 'numeric'
  },
  date: {
    year: 'numeric',
    month: 'long',
    day: 'numeric'
  },
  'weekday-date': {
    weekday: 'long',
    year: 'numeric',
    month: 'long',
    day: 'numeric'
  },
  none: {},
  'numeric-date': {
    year: 'numeric',
    month: 'numeric',
    day: 'numeric'
  }
};
export var getPresetDateTimeOptions = function getPresetDateTimeOptions(type) {
  return dateTimePresets[type] || dateTimePresets.none;
};
var pseudoDate = function pseudoDate(date) {
  return date.replace(/[\/\-\,\:]/g, '.');
};
var pseudoFormatPart = function pseudoFormatPart(_ref) {
  var type = _ref.type,
    value = _ref.value;
  return type === 'literal' ? {
    type: type,
    value: '.'
  } : {
    type: type,
    value: value
  };
};
function formatterFactory(formatterLocale, options) {
  try {
    return new DateTimeFormatter(transformDateOptions(formatterLocale, options));
  } catch (error) {
    console.error("@procore/core-react Intl.DateTimeFormat error for locale ".concat(formatterLocale, ". Will fall back to en-US"), error);
    return new DateTimeFormatter(transformDateOptions('en-US', options));
  }
}
function transformDateOptions(formatterLocale, options) {
  var isDefined = function isDefined(val) {
    return val !== undefined;
  };
  return R.pickBy(isDefined, _objectSpread(_objectSpread({}, {
    locale: formatterLocale
  }), options));
}
var mapFormatToParts = function mapFormatToParts(parts) {
  return parts.map(pseudoFormatPart);
};
export function intlDateTimeFormat(locale) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!locale) {
    throw new Error('Locale is a required parameter.');
  }
  var formatterLocale = getFormatterLocale(locale);
  var formatter = formatterFactory(formatterLocale, options);
  return locale === 'pseudo' ? {
    format: function format(date) {
      return pseudoDate(formatter.formatDateTime(date));
    },
    formatToParts: function formatToParts(date) {
      return mapFormatToParts(formatter.formatDateTimeToParts(date));
    },
    resolvedOptions: function resolvedOptions() {
      return formatter.formatter.resolvedOptions();
    }
  } : {
    format: function format(date) {
      return formatter.formatDateTime(date);
    },
    formatToParts: function formatToParts(date) {
      return formatter.formatDateTimeToParts(date);
    },
    resolvedOptions: function resolvedOptions() {
      return formatter.formatter.resolvedOptions();
    }
  };
}
export function toDate(date, log) {
  if (date instanceof Date) {
    return date;
  }
  if (!isNaN(Date.parse(date))) {
    return new Date(date);
  }
  if (log) {
    console.warn("@procore/core-react: ".concat(log, "; toDate invalid date format"), date);
  }
  return date;
}

// Date should already be shifted to the time zone, meaning we already have the date in location and
// now we need it in a specific style https://developer.mozilla.org/en-US/docs/Web/HTML/Element/time#valid_datetime_values
// toLocaleDateString uses Intl DateTimeFormat
// alternative toLocaleDateString('en-GB', { timeZone })
export function formatMachineDate(date) {
  return date.toLocaleDateString('en-GB').split('/').reverse().join('-');
}
//# sourceMappingURL=dateTime.js.map